using System;
using System.ComponentModel;
using System.Globalization;
using System.Runtime.Serialization;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using System.Reflection;
using System.Xml.Serialization;
using System.Drawing;

using Symcon.LightRidge.BusinessObjects.TypeConverters;

using Syncfusion.Windows.Forms.Diagram;
using System.Drawing.Drawing2D;
namespace Symcon.Lightridge.LRRUI.Controls
{
	[Serializable()]
	public class CustomProperties : Node//Symbol //Syncfusion compilation change..
	{
		#region Constructor
		/// <summary>
		/// Default constructor.
		/// </summary>
		public CustomProperties()
		{
			SetPropertyTable();
			this.ID=Guid.NewGuid().ToString();
            //RotateCmd rtCmd = new RotateCmd(); //Syncfusion compilation change..
			//CreateLabels();
			ArryIndexedProps = new ArrayList();

			for(int i = 0;i<4;i++)
			{
				ArryIndexedProps.Add("Null");
			}
            SymbolsUtils.CreateLabels(this); 
		}





		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
		public CustomProperties(CustomProperties src) : base(src)
		{
			try
			{
				CustomProperties sourceCustProp = src as CustomProperties;
				CustomProperties targetCustProp = this;

				targetCustProp.PT = null;
				targetCustProp.MasterPlantItem = null;
				targetCustProp.PlantItem = null;

                //Syncfusion compilation change..

                //targetCustProp.FillStyle.AlphaFactor = sourceCustProp.FillStyle.AlphaFactor;
                //targetCustProp.FillStyle.Color = sourceCustProp.FillStyle.Color;
                //targetCustProp.FillStyle.GradientAngle = sourceCustProp.FillStyle.GradientAngle;
                //targetCustProp.FillStyle.GradientBounds = sourceCustProp.FillStyle.GradientBounds;
                //targetCustProp.FillStyle.GradientStartColor = sourceCustProp.FillStyle.GradientStartColor;
                //targetCustProp.FillStyle.Texture = sourceCustProp.FillStyle.Texture;
                //targetCustProp.FillStyle.TextureWrapMode = sourceCustProp.FillStyle.TextureWrapMode;
                //targetCustProp.FillStyle.Type = sourceCustProp.FillStyle.Type;
                
                //Syncfusion compilation change..
                //targetCustProp.EditStyle.AllowMove = sourceCustProp.EditStyle.AllowMove;
                //targetCustProp.EditStyle.AllowResize = sourceCustProp.EditStyle.AllowResize;
				targetCustProp.EditStyle.AllowRotate = sourceCustProp.EditStyle.AllowRotate;
				targetCustProp.EditStyle.AllowSelect = sourceCustProp.EditStyle.AllowSelect;
				targetCustProp.EditStyle.AllowVertexEdit = sourceCustProp.EditStyle.AllowVertexEdit;
				targetCustProp.EditStyle.DefaultHandleEditMode = sourceCustProp.EditStyle.DefaultHandleEditMode;

				targetCustProp.LineStyle.DashCap = sourceCustProp.LineStyle.DashCap;
				targetCustProp.LineStyle.DashOffset = sourceCustProp.LineStyle.DashOffset;
				targetCustProp.LineStyle.DashStyle = sourceCustProp.LineStyle.DashStyle;
				targetCustProp.LineStyle.EndCap = sourceCustProp.LineStyle.EndCap;
				targetCustProp.LineStyle.LineColor = sourceCustProp.LineStyle.LineColor;
				targetCustProp.LineStyle.LineJoin = sourceCustProp.LineStyle.LineJoin;
				targetCustProp.LineStyle.LineWidth = sourceCustProp.LineStyle.LineWidth;
				targetCustProp.LineStyle.MiterLimit = sourceCustProp.LineStyle.MiterLimit;
                
                //Syncfusion compilation change..
                //targetCustProp.Width = sourceCustProp.Width;
                //targetCustProp.Height = sourceCustProp.Height;
                //targetCustProp.Length = sourceCustProp.Length;
                targetCustProp.Size = sourceCustProp.Size;

				targetCustProp.Visible = sourceCustProp.Visible;
                //Syncfusion compilation change.
                //targetCustProp.AutoHidePorts = sourceCustProp.AutoHidePorts;


				targetCustProp.ArryIndexedProps = null;
				targetCustProp.ArryIndexedProps = sourceCustProp.ArryIndexedProps.Clone() as ArrayList;
				for (int i = 0; i < 4; i++)
				{
					targetCustProp.ArryIndexedProps[i] = "Null";
				}
				SetPropertyTable();
			}
			catch (Exception ex)
			{

			}
		}

		

		/// <summary>
		/// Serialization constructor for the MySymbol class.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected CustomProperties(SerializationInfo info, StreamingContext context) : base(info, context)
		{
			// The Serialization constructor is invoked during deserialization or during a drag & drop operation.
			// If the MySymbol type has serializable members, then initialize them with the serialized data 
			// obtained from the SerializationInfo param
		}

		// Override SymbolBase.GetObjectData() and populate the SerializationInfo param 
		// with the data (if any) that belongs to the MySymbol type . This data will be 
		// serialized as a part of the Symbol object.

		#endregion

		#region Overrides
		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against</returns>
		public override object Clone()
		{
			return new CustomProperties(this);
		}

        //Syncfusion compilation change..
        //protected override void OnBoundsChanged(BoundsEventArgs evtArgs)
        //{
        //    base.OnBoundsChanged (evtArgs);
        //    for(int j = this.Ports.Count ; j>0; j--)
        //    {
        //        this.Ports.Remove(this.Ports[j-1]);
        //    }                                         
        //    float xoffset = this.X;
        //    while(xoffset < (this.X + this.Width))
        //    {
        //        PointF ptworld = new PointF(xoffset, this.Location.Y + this.Height / 2);
        //        PointF[] pts = new PointF[] {ptworld};
        //        Matrix worldxform = this.WorldTransform;
        //        worldxform.Invert();
        //        worldxform.TransformPoints(pts);
        //        CirclePort cPort = new CirclePort(pts[0]);
        //        this.Ports.Add(cPort);
        //        xoffset += 10f;                                             
        //    } 
        //}

		#endregion

		#region	Public Properties 
		
		/// <summary>
		/// Link to Navigate to when symbol is double-clicked
		/// </summary>
		[Browsable(true),TypeConverter(typeof(LinkTypeConverter)),ReadOnly(false)]
		public Symcon.LightRidge.BusinessObjects.GraphicalLink Link
		{
			get
			{
                //Syncfusion compilation change...
                //object value = this.GetPropertyValue("Link");
                object value = this.GetPropertyContainerByName("Link");
				if (value != null && value.GetType() != typeof(string))
				{
					return (Symcon.LightRidge.BusinessObjects.GraphicalLink) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation change...

                //this.SetPropertyValue("Link", value);
                //this.Labels["Link"].Text = Link.Name;
                this.SetPropertyTable();
                ((PathNode)((Node)this)).Labels["Link"].Text = Link.Name;
			}
		}




		/// <summary>
		/// Link Id
		/// </summary>
		[Browsable(false),ReadOnly(false)]
		public string LinkID
		{
			get
			{
                //Syncfusion compilation change...
                //object value = this.GetPropertyValue("LinkID");
                object value = this.GetPropertyContainerByName("LinkID");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation change...
                //this.SetPropertyValue("LinkID", value);
                this.SetPropertyTable();
			}
		}


		/// <summary>
		/// The Type of Master Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(true),TypeConverter(typeof(SymbolTypeConverter)), 
		CategoryAttribute("Binding Information")]
		public Symcon.LightRidge.BusinessObjects.MasterPlantItem MasterPlantItem
		{
			get
			{
                //Syncfusion compilation change...
                //object value = this.GetPropertyValue("MasterPlantItem");
                object value = this.GetPropertyContainerByName("MasterPlantItem");
				if (value != null)
				{
					return (Symcon.LightRidge.BusinessObjects.MasterPlantItem) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation change...
                //this.SetPropertyValue("MasterPlantItem", value);
                //this.SetPropertyValue("PlantItem", null);
                this.SetPropertyTable();
			}
		}


		/// <summary>
		/// The Type of Master Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(false),TypeConverter(typeof(SymbolTypeConverter)), 
		CategoryAttribute("Binding Information")]
		public string ItemType
		{
			get
			{
                //Syncfusion compilation change...
                //object value = this.GetPropertyValue("ItemType");
                object value = this.GetPropertyContainerByName("ItemType");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation change...
                //this.SetPropertyValue("ItemType", value);
                //this.SetPropertyValue("SiteItem", null);
                this.SetPropertyTable();
			}
		}


		/// <summary>
		/// The Type of Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(true),TypeConverter(typeof(ObjectNameConverter)), 
		CategoryAttribute("Binding Information")]
		public Symcon.LightRidge.BusinessObjects.SiteItem PlantItem
		{
			get
			{
                //Syncfusion compilation change...
                //object value = this.GetPropertyValue("PlantItem");
                object value = this.GetPropertyContainerByName("PlantItem");
				if (value != null)
				{
					return (Symcon.LightRidge.BusinessObjects.SiteItem) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation change...
                //this.SetPropertyValue("PlantItem", value);
                this.SetPropertyTable();
			}
		}



		/// <summary>
		/// The Type of Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(false),TypeConverter(typeof(ObjectNameConverter)), 
		CategoryAttribute("Binding Information")]
		public string SiteItem
		{
			get
			{
                //Syncfusion compilation change...
                //object value = this.GetPropertyValue("SiteItem");
                object value = this.GetPropertyContainerByName("SiteItem");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation change...
                //this.SetPropertyValue("SiteItem", value);
                this.SetPropertyTable();
			}
		}

        //Syncfusion compilation change..
        ///// <summary>
        ///// The Width of Symbol
        ///// </summary>
        //[Browsable(true)]
        //public float Length
        //{
        //    get
        //    {
        //        return (float) base.Width;
        //    }
        //    set
        //    {
        //        if (value == 0)
        //        {
        //            value = .01f;
        //        }
        //        base.Width = value;
        //    }
        //}

        ///// <summary>
        ///// The Width of Symbol
        ///// </summary>
        //[Browsable(true)]
        //public new float Height
        //{
        //    get
        //    {
        //        return (float) base.Height;
        //    }
        //    set
        //    {
        //        if (value == 0)
        //        {
        //            value = .01f;
        //        }
        //        base.Height = value;
        //    }
        //}
        [Browsable(true)]
        public SizeF Size
        {
            get
            {
                return (SizeF)base.Size;
            }
            set
            {

                base.Size = value;
            }
        }

        //Syncfusion compilation changes..

        ///// <summary>
        ///// The X Cordinate of Symbol w.r.t the Canvas
        ///// </summary>
        //[Browsable(true)]
        //public new float X
        //{
        //    get
        //    {
        //        return base.X;
        //    }
        //    set
        //    {
        //        base.X = value;
        //    }
        //}


        ///// <summary>
        ///// The Y Cordinate of Symbol w.r.t the Canvas
        ///// </summary>
        //[Browsable(true)]
        //public new float Y
        //{
        //    get
        //    {
        //        return base.Y;
        //    }
        //    set
        //    {
        //        base.Y = value;
        //    }
        //}



		/// <summary>
		/// Set of Labels 
		/// </summary>
		[Browsable(false)]
		public LabelCollection BoundProperties
		{
			get
			{
                //Syncfusion compilation change..
                //return base.Labels;
                return ((PathNode)((Node)this)).Labels;
			}
		}

		/// <summary>
		/// PropertyTable Associated With the symbol
		/// </summary>
		[Browsable(false)]
		public PropertyTable PT
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("PT");
                object value = this.GetPropertyContainerByName("PT");
				if (value != null)
				{
					return (PropertyTable) value;
				}
				PT = new PropertyTable();
				return null;
			}
			set
			{
				try
				{
                    //Syncfusion compilation change..
                    //this.SetPropertyValue("PT", value);
                    this.SetPropertyTable();
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false), ReadOnly(false)]
		public string SymbolName 
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("SymbolName");
                object value = this.GetPropertyContainerByName("SymbolName");
				if (value != null)
				{
					return (string) value;
				}
				return "Test";
			}
			set
			{
				try
				{
                    //Syncfusion compilation change..
                    //this.SetPropertyValue("SymbolName", value);
                    this.SetPropertyTable();
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false), ReadOnly(false)]
		public string ID
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("ID");
                object value = this.GetPropertyContainerByName("ID");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
				try
				{
                    //Syncfusion compilation change..
                    //this.SetPropertyValue("ID", value);
                    this.SetPropertyTable();
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false),ReadOnly(false)]
		public ArrayList ArryIndexedProps
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("ArryIndexedProps");
                object value = this.GetPropertyContainerByName("ArryIndexedProps");
				if (value != null)
				{
					return (ArrayList) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation change..
                //this.SetPropertyValue("ArryIndexedProps", value);
                this.SetPropertyTable();
			}
				
		}

		#endregion

		#region Overrides


		#endregion

		#region Methods



		private void SetPropertyTable()
		{
			if(PT == null)
			{
				try
				{
					PropertyInfo[] properties =	this.GetType().GetProperties(BindingFlags.Instance | BindingFlags.DeclaredOnly | BindingFlags.Public);
				
					foreach	(PropertyInfo property in properties)
					{
						BrowsableAttribute[] attr = property.GetCustomAttributes(typeof(BrowsableAttribute),false) as BrowsableAttribute[];
						if(attr.Length > 0)
							if(((BrowsableAttribute)attr[0]).Browsable == false)
								continue;
						string propname	= property.Name;
						if(property.Name == "MasterPlantItem")
						{
							//PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Select the Type of Symbol" ,this.GetPropertyValue(property.Name),"",typeof(SymbolTypeConverter),this));
                            //Syncfusion compilation change..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists of Master Plant Item" ,this.GetPropertyValue(property.Name),"",typeof(SymbolTypeConverter),this));
                            PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "Binding Information", "Lists of Master Plant Item", this.GetPropertyContainerByName(property.Name), "", typeof(SymbolTypeConverter), this));
						}
						else if(property.Name == "PlantItem" )
						{
							//PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists the Bound objects of selected type" ,this.GetPropertyValue(property.Name),"",typeof(ObjectNameConverter),this));
                            
                            //Syncfusion compilation change..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists the Plant Item objects of Selected Master Plant Item",this.GetPropertyValue(property.Name),"",typeof(ObjectNameConverter),this));
                            PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "Binding Information", "Lists the Plant Item objects of Selected Master Plant Item", this.GetPropertyContainerByName(property.Name), "", typeof(ObjectNameConverter), this));
							
                            //siteitemps = new PropertySpec("PlantItem",typeof(SiteItem),"Binding Information","Lists the Plant Item objects of Selected Master Plant Item" ,si,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.ObjectNameConverter),sm);
						}
						else if(property.Name == "Link")
						{
                            //Syncfusion compilation change..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Link","Select the Link for the Symbol" ,this.GetPropertyValue(property.Name),"",typeof(LinkTypeConverter),this));
                            PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "Link", "Select the Link for the Symbol", this.GetPropertyContainerByName(property.Name), "", typeof(LinkTypeConverter), this));
						}
						else
						{
                            //Syncfusion compilation change..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"General	Properties","Sets the " + property.Name + " property of selected symbol",this.GetPropertyValue(property.Name),"","", this));
                            PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "General	Properties", "Sets the " + property.Name + " property of selected symbol", this.GetPropertyContainerByName(property.Name), "", "", this));
						}
					}
				}	
				catch(Exception	ex)
				{
					Debug.Assert(false,ex.Message);
				}
			}
		}

		#endregion

		#region Fields
		private string					id;
		#endregion
	}
}
