using System;
using System.ComponentModel;
using System.Globalization;
using System.Runtime.Serialization;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using System.Reflection;
using System.Xml.Serialization;
using System.Drawing;

using Symcon.LightRidge.BusinessObjects.TypeConverters;

using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls; //Syncfusion compilation change..
using System.Drawing.Drawing2D;
using System.Drawing.Design;

namespace Symcon.Lightridge.LRRUI.Controls
{
	[Serializable()]
    public class DynamicGridcontainer : Node //Symbol //Syncfusion compilation change..
	{
		#region Constructors

		public DynamicGridcontainer()
		{
			//ctxMenu = new ContextMenu();

			this.ID = Guid.NewGuid().ToString();
			this.outerRect = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 100, 40);
			this.outerRect.Name = "OuterRectangle";
			this.outerRect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
            //Syncfusion compilation change..
            //this.outerRect.FillStyle.GradientStartColor = System.Drawing.Color.Orange;
			this.outerRect.FillStyle.Color = Color.Orange;
			this.outerRect.ShadowStyle.Visible = true;
			//this.outerRect = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 100, 40);
			this.EditStyle.DefaultHandleEditMode = HandleEditMode.None;


			AddHeader();
            //AddGridCells(); //Syncfusion compilation change..
			SetPropertyTable();
            //this.EditStyle.AllowResize = false; //Syncfusion compilation change..
            this.FontFamily = "Arial";

		}


		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
		public DynamicGridcontainer(DynamicGridcontainer src)
			: base(src)
		{
			

			DynamicGridcontainer sourceGrid = src as DynamicGridcontainer;
			DynamicGridcontainer targetGrid = this;
            //Syncfusion compilation change..
            //targetGrid._headerCell = this.Labels[0] as GridHeaderCell;

            //targetGrid._headerCell.Height = src.Labels[0].Height;
			targetGrid.PT = null;
			//dimensions
			targetGrid._oldCols = sourceGrid.Columns; //sourceGrid._oldCols;
			targetGrid._oldRows = sourceGrid.Rows;// sourceGrid._oldRows;

			targetGrid._cols = sourceGrid.Columns;
			targetGrid._rows = sourceGrid.Rows;
			targetGrid.RowHeight = sourceGrid.RowHeight;
			targetGrid.ColumnWidth = sourceGrid.ColumnWidth;
            //Syncfusion compilation change..
            //targetGrid.Height = sourceGrid.Height;
            //targetGrid.Width = sourceGrid.Width;

			//font
			targetGrid.FontFamily = sourceGrid.FontFamily;
			targetGrid.CellsFontFamily = sourceGrid.CellsFontFamily;
			targetGrid.FontSize = sourceGrid.FontSize;


			//formatting 

			targetGrid.BorderColor = sourceGrid.BorderColor;
			targetGrid.BorderWidth = sourceGrid.BorderWidth;
			targetGrid.CellsBackColor = sourceGrid.CellsBackColor;
			targetGrid.CellsForeColor = sourceGrid.CellsForeColor;
			targetGrid.GridBorderColor = sourceGrid.GridBorderColor;
			targetGrid.GridBorderWidth = sourceGrid.GridBorderWidth;

            //Syncfusion compilation change.
			//style
            //targetGrid.BackGroundStyle.Color = sourceGrid.BackGroundStyle.Color;
            //targetGrid.BackGroundStyle.GradientAngle = sourceGrid.BackGroundStyle.GradientAngle;
            //targetGrid.BackGroundStyle.GradientBounds = sourceGrid.BackGroundStyle.GradientBounds;
            //targetGrid.BackGroundStyle.GradientStartColor = sourceGrid.BackGroundStyle.GradientStartColor;
            //targetGrid.BackGroundStyle.Texture = sourceGrid.BackGroundStyle.Texture;
            //targetGrid.BackGroundStyle.TextureWrapMode = sourceGrid.BackGroundStyle.TextureWrapMode;
            //targetGrid.BackGroundStyle.Type = sourceGrid.BackGroundStyle.Type;

            //Syncfusion compilation change..
            //targetGrid.EditStyle.AllowMove = sourceGrid.EditStyle.AllowMove;
            //targetGrid.EditStyle.AllowResize = sourceGrid.EditStyle.AllowResize;
			targetGrid.EditStyle.AllowRotate = sourceGrid.EditStyle.AllowRotate;
			targetGrid.EditStyle.AllowSelect = sourceGrid.EditStyle.AllowSelect;
			targetGrid.EditStyle.AllowVertexEdit = sourceGrid.EditStyle.AllowVertexEdit;
			targetGrid.EditStyle.DefaultHandleEditMode = sourceGrid.EditStyle.DefaultHandleEditMode;
			targetGrid.EditStyle.Enabled = sourceGrid.EditStyle.Enabled;
            
            //Syncfusion compilation change..
            //targetGrid.FillStyle.AlphaFactor = sourceGrid.FillStyle.AlphaFactor;
            targetGrid.FillStyle.ColorAlphaFactor = sourceGrid.FillStyle.ColorAlphaFactor;
			targetGrid.FillStyle.Color = sourceGrid.FillStyle.Color;
			targetGrid.FillStyle.GradientAngle = sourceGrid.FillStyle.GradientAngle;
            //Syncfusion compilation change..
            //targetGrid.FillStyle.GradientBounds = sourceGrid.FillStyle.GradientBounds;
            //targetGrid.FillStyle.GradientStartColor = sourceGrid.FillStyle.GradientStartColor;
			targetGrid.FillStyle.Texture = sourceGrid.FillStyle.Texture;
			targetGrid.FillStyle.TextureWrapMode = sourceGrid.FillStyle.TextureWrapMode;
			targetGrid.FillStyle.Type = sourceGrid.FillStyle.Type;

			targetGrid.LineStyle.DashCap = sourceGrid.LineStyle.DashCap;
			targetGrid.LineStyle.DashOffset = sourceGrid.LineStyle.DashOffset;
			targetGrid.LineStyle.DashStyle = sourceGrid.LineStyle.DashStyle;
			targetGrid.LineStyle.EndCap = sourceGrid.LineStyle.EndCap;
			targetGrid.LineStyle.LineColor = sourceGrid.LineStyle.LineColor;
			targetGrid.LineStyle.LineJoin = sourceGrid.LineStyle.LineJoin;
			targetGrid.LineStyle.LineWidth = sourceGrid.LineStyle.LineWidth;
			targetGrid.LineStyle.MiterLimit = sourceGrid.LineStyle.MiterLimit;

			targetGrid.TextStyle = sourceGrid.TextStyle;

			//alignment
			targetGrid.HorizontalAlignment = sourceGrid.HorizontalAlignment;
			targetGrid.VerticalAlignment = sourceGrid.VerticalAlignment;

		 
			targetGrid.ShowGridLines = sourceGrid.ShowGridLines;
			targetGrid.Visible = sourceGrid.Visible;

			 SetPropertyTable();

	   



		}

		/// <summary>
		/// Serialization constructor for the MySymbol class.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected DynamicGridcontainer(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
			try
			{
				this._gridlineColor = (System.Drawing.Color)info.GetValue("_gridlineColor", typeof(System.Drawing.Color));
				this._gridBorderWidth = (int)info.GetInt32("_gridBorderWidth");
				this._colWidth = info.GetInt32("_colWidth");
				this._showGridlines = (bool)info.GetBoolean("_showGridlines");
				this._cols = (int)info.GetInt32("_cols");
				this._rows = (int)info.GetInt32("_rows");
				this._topLabelHeight = (float)info.GetSingle("_topLabelHeight");
				this._gridCellFont = (int)info.GetInt32("_gridCellFont");


				this._gridCellFontFamily = (string)info.GetString("_gridCellFontFamily");
				this._cellsForeColor = (System.Drawing.Color)info.GetValue("_cellsForeColor", typeof(System.Drawing.Color));
				this._cellsBackColor = (System.Drawing.Color)info.GetValue("_cellsBackColor", typeof(System.Drawing.Color));
                //this._totalColumns = (int)info.GetInt32("_totalColumns");
                //this._totalRows = (int)info.GetInt32("_totalRows");
			}
			catch (Exception ex)
			{

			}

			// The Serialization constructor is invoked during deserialization or during a drag & drop operation.
			// If the Symbol type has serializable members, then initialize them with the serialized data 
			// obtained from the SerializationInfo param
		}


		#endregion

		#region Overrides

		public override object Clone()
		{
			return new DynamicGridcontainer(this);
		}

        //Syncfusion compilation change.
        //protected override void OnDeserialization(object sender)
        //{
        //    base.OnDeserialization(sender);
        //    foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in this.Labels)
        //    {
        //        if (lbl.GetType() == typeof(GridCell))
        //        {
        //            GridCell grdCell = lbl as GridCell;
        //            grdCell.GridCellClick +=new NodeMouseEventHandler(cellCtrl_GridCellClick);
        //            grdCell.RowSpanChanged +=new EventHandler(grdCell_RowSpanChanged);
        //            grdCell.ColumnSpanChanged +=new EventHandler(grdCell_ColumnSpanChanged);
        //        }
        //        else if (lbl.GetType() == typeof(GridHeaderCell))
        //        {
        //            GridHeaderCell grdCell = lbl as GridHeaderCell;
        //            _headerCell = lbl as GridHeaderCell;
        //            grdCell.HeaderCellClick +=new NodeMouseEventHandler(cellCtrl_GridCellClick);
        //        }
        //    }
        //    outerRect = this.Nodes.GetNodeByName("OuterRectangle") as Syncfusion.Windows.Forms.Diagram.Rectangle;
        //}

		void grdCell_ColumnSpanChanged(object sender, EventArgs e)
		{
			try
			{
				GridCell grdCell = sender as GridCell;
				if (grdCell.OldColumnSpan < grdCell.ColSpan)
				{
					bool success = MergeHorizontal(grdCell);
					if (!success)
					{
						grdCell.ResetColSpan();
					}
					else
					{
						grdCell.OldColumnSpan = grdCell.ColSpan;
					}
				}
				else
				{
					//grdCell.ColSpan = grdCell.OldColumnSpan;
					bool success = UnMergeVertical(grdCell);
					if (!success)
					{
						grdCell.ResetColSpan();
					}
					else
					{
						grdCell.OldColumnSpan = grdCell.ColSpan;
					}
				}
                //Syncfusion compilation change.
                //if (_model != null)
                //{
                //    _model.UpdateViews();
                //}
			}
			catch
			{ }
		}

		private bool MergeHorizontal(GridCell grdCell)
		{
			int lastColumnIndex = this.Columns;
			float offsetX = 0;
			float width = 0;
			if (grdCell.ColumnIndex + grdCell.ColSpan > lastColumnIndex)
			{
				return false;
			}
			else
			{
                //Syncfusion compilation changes...
                //for (int i = this.Labels.Count; i > 0; i--)
                for (int i = ((PathNode)((Node)this)).Labels.Count; i > 0; i--)
				{
					if (i == 1)
						continue;
					else
					{
                        //Syncfusion compilation changes...
                        //GridCell currentGridCell = this.Labels[i - 1] as GridCell;
                        GridCell currentGridCell = ((PathNode)((Node)this)).Labels[i - 1] as GridCell;
						if (currentGridCell.ColumnIndex > grdCell.ColumnIndex && currentGridCell.ColumnIndex <= grdCell.ColumnIndex + grdCell.ColSpan - 1 && currentGridCell.RowIndex < grdCell.RowIndex && currentGridCell.RowIndex + currentGridCell.RowSpan > grdCell.RowIndex && currentGridCell != grdCell)
						{
							return false;
						}
						if (currentGridCell.ColumnIndex > grdCell.ColumnIndex && currentGridCell.ColumnIndex <= grdCell.ColumnIndex + grdCell.ColSpan - 1 && (currentGridCell.RowIndex >= grdCell.RowIndex && currentGridCell.RowIndex < grdCell.RowIndex + grdCell.RowSpan) && currentGridCell != grdCell)
						{
							if (currentGridCell.RowIndex + currentGridCell.RowSpan > grdCell.RowIndex + grdCell.RowSpan)
							{
								return false;
							}
						}
					}
				}
                //Syncfusion compilation changes...
                //for (int i = this.Labels.Count; i > 0; i--)
                for (int i = ((PathNode)((Node)this)).Labels.Count; i > 0; i--)
				{
					if (i == 1)
						continue;
					else
					{
                        //Syncfusion compilation changes...
                        //GridCell currentGridCell = this.Labels[i - 1] as GridCell;
                        GridCell currentGridCell = ((PathNode)((Node)this)).Labels[i - 1] as GridCell;

						//if (grdCell.RowSpan == 1)
						//{
						//   if (currentGridCell.ColumnIndex >  grdCell.ColumnIndex && currentGridCell.ColumnIndex <= grdCell.ColumnIndex + grdCell.ColSpan - 1 && currentGridCell.RowIndex == grdCell.RowIndex && currentGridCell != grdCell)
						//   {
						//      width = width + currentGridCell.Width;
						//      offsetX = offsetX + currentGridCell.Width / 2;
						//      this.Labels.Remove(currentGridCell);
						//   }
						//}
						//else
						//{
						if (currentGridCell.ColumnIndex > grdCell.ColumnIndex && currentGridCell.ColumnIndex <= grdCell.ColumnIndex + grdCell.ColSpan - 1 && (currentGridCell.RowIndex >= grdCell.RowIndex && currentGridCell.RowIndex < grdCell.RowIndex + grdCell.RowSpan) && currentGridCell != grdCell)
						{
                            //Syncfusion compilation changes...

                            //width = width + (currentGridCell.Width / grdCell.RowSpan * currentGridCell.RowSpan);
                            //offsetX = offsetX + ((currentGridCell.Width / grdCell.RowSpan * currentGridCell.RowSpan) / 2);
                            //this.Labels.Remove(currentGridCell);
                            width = width + (currentGridCell.Size.Width / grdCell.RowSpan * currentGridCell.RowSpan);
                            offsetX = offsetX + ((currentGridCell.Size.Width / grdCell.RowSpan * currentGridCell.RowSpan) / 2);
                            ((PathNode)((Node)this)).Labels.Remove(currentGridCell);
						}
						//}
					}
				}
				if (width > 0)
				{
					GridCell newGrdCell = grdCell;
                    //Syncfusion compilation changes...
                    //newGrdCell.OffsetX = newGrdCell.OffsetX + offsetX;
                    //newGrdCell.Width = newGrdCell.Width + width;
					return true;
				}
				return false;
			}

		}



		private bool MergeVertical(GridCell grdCell)
		{
			int lastRowIndex = this.Rows;
			float offsetY = 0;
			float height = 0;


			if (grdCell.RowIndex + grdCell.RowSpan > lastRowIndex)
			{
				return false;
			}
			else
			{
                //Syncfusion compilation changes...
                //for (int i = this.Labels.Count; i > 0; i--)
                for (int i = ((PathNode)((Node)this)).Labels.Count; i > 0; i--)
				{
					if (i == 1)
						continue;
					else
					{
                        //Syncfusion compilation changes...
                        //GridCell currentGridCell = this.Labels[i - 1] as GridCell;
                        GridCell currentGridCell = ((PathNode)((Node)this)).Labels[i - 1] as GridCell;
						if (currentGridCell.RowIndex > grdCell.RowIndex && currentGridCell.RowIndex <= grdCell.RowIndex + grdCell.RowSpan - 1 && currentGridCell.ColumnIndex < grdCell.ColumnIndex && currentGridCell.ColumnIndex + currentGridCell.ColSpan > grdCell.ColumnIndex && currentGridCell != grdCell)
						{
							return false;
						}
						if (currentGridCell.RowIndex > grdCell.RowIndex && currentGridCell.RowIndex <= grdCell.RowIndex + grdCell.RowSpan - 1 && (currentGridCell.ColumnIndex >= grdCell.ColumnIndex && currentGridCell.ColumnIndex < grdCell.ColumnIndex + grdCell.ColSpan) && currentGridCell != grdCell)
						{

							if (currentGridCell.ColumnIndex + currentGridCell.ColSpan > grdCell.ColumnIndex + grdCell.ColSpan)
							{
								return false;
							}
						}
					}
				}
                //Syncfusion compilation changes...
                //for (int i = this.Labels.Count; i > 0; i--)
                for (int i = ((PathNode)((Node)this)).Labels.Count; i > 0; i--)
				{
					if (i == 1)
						continue;
					else
					{
                        //Syncfusion compilation changes...
                        //GridCell currentGridCell = this.Labels[i - 1] as GridCell;
                        GridCell currentGridCell = ((PathNode)((Node)this)).Labels[i - 1] as GridCell;

						if (currentGridCell.RowIndex > grdCell.RowIndex && currentGridCell.RowIndex <= grdCell.RowIndex + grdCell.RowSpan - 1 && (currentGridCell.ColumnIndex >= grdCell.ColumnIndex && currentGridCell.ColumnIndex < grdCell.ColumnIndex + grdCell.ColSpan) && currentGridCell != grdCell)
						{
                            //Syncfusion compilation changes...

                            //height = height + (currentGridCell.Height / grdCell.ColSpan * currentGridCell.ColSpan);
                            ////	height = height + currentGridCell.Height;
                            //offsetY = offsetY + ((currentGridCell.Height / grdCell.ColSpan * currentGridCell.ColSpan) / 2);
                            ////offsetY = offsetY + currentGridCell.Height / 2;
                            //this.Labels.Remove(currentGridCell);
                            height = height + (currentGridCell.Size.Height / grdCell.ColSpan * currentGridCell.ColSpan);
                            offsetY = offsetY + ((currentGridCell.Size.Height / grdCell.ColSpan * currentGridCell.ColSpan) / 2);
                            ((PathNode)((Node)this)).Labels.Remove(currentGridCell);
						}
					}
				}
				if (height > 0)
				{
                    //Syncfusion compilation changes...
                    //GridCell newGrdCell = grdCell;
                    //newGrdCell.OffsetY = newGrdCell.OffsetY + offsetY;
                    //newGrdCell.Height = newGrdCell.Height + height;
					return true;
				}
				else
				{
					return false;
				}
				//return false;
			}

		}

		private bool UnMergeVertical(GridCell grdCell)
		{
			int lastRowIndex = this.Rows;
			//float offsetY = 0;
			//float height = 0;

			bool success = false;
			if (grdCell.RowSpan != grdCell.OldRowSpan)
			{
				if (grdCell.RowSpan != 1)
				{
					return false;
				}
				float yPos = grdCell.RowIndex * 20;

				for (int i = 0; i < grdCell.OldRowSpan; i++)
				{
                    //Syncfusion compilation changes...
                    //float ctrlWidth = grdCell.Width;// / grdCell.ColSpan;
                    //float ctrlHeight = grdCell.Height / grdCell.OldRowSpan;
                    float ctrlWidth = grdCell.Size.Width;// / grdCell.ColSpan;
                    float ctrlHeight = grdCell.Size.Height / grdCell.OldRowSpan;

					float xPos = grdCell.ColumnIndex * 50;

					int index = 0;
					//   for (int iRow = grdCell.RowIndex; iRow < grdCell.RowIndex+ grdCell.OldRowSpan; iRow++)
					//{		xPos = grdCell.ColumnIndex * 50;
					//for (int iCol = grdCell.ColumnIndex; iCol < grdCell.OldColumnSpan; iCol++)
					//{
					GridCell cellCtrl = new GridCell();
                    //Syncfusion compilation changes...
                    //cellCtrl.GridCellClick +=new NodeMouseEventHandler(cellCtrl_GridCellClick);
                    //this.Labels.Add(cellCtrl);
                    //cellCtrl.Anchor = BoxPosition.TopLeft;
                    ((PathNode)((Node)this)).Labels.Add(cellCtrl);
                    cellCtrl.Position = Position.TopLeft;

					cellCtrl.OffsetX = xPos + ctrlWidth / 2;
					cellCtrl.OffsetY = yPos + ctrlHeight / 2 + _topLabelHeight;
					cellCtrl.ReadOnly = false;
					cellCtrl.RowIndex = grdCell.RowIndex + i;
					cellCtrl.ColumnIndex = grdCell.ColumnIndex;
                    //Syncfusion compilation changes...
                    //cellCtrl.BorderStyle.ShowBorder = true;
                    //cellCtrl.BorderStyle.BorderColor = Color.DimGray;

					//cellCtrl.WrapText = false;

                    //Syncfusion compilation changes...
                    //cellCtrl.Width = ctrlWidth;
                    //cellCtrl.Height = ctrlHeight;

					cellCtrl.OldRowSpan = grdCell.RowSpan;
					cellCtrl.OldColumnSpan = grdCell.ColSpan;
					cellCtrl.RowSpan = grdCell.RowSpan;
					cellCtrl.ColSpan = grdCell.ColSpan;
					cellCtrl.ColumnSpanChanged +=new EventHandler(grdCell_ColumnSpanChanged);
					cellCtrl.RowSpanChanged +=new EventHandler(grdCell_RowSpanChanged);
					yPos = yPos + ctrlHeight;
					index++;
					//}
					//yPos = yPos + ctrlHeight;
					//}
					_gridlineColor = Color.DimGray;
					_gridBorderWidth = 1;
					_gridCellFont = 12;
				}
                //Syncfusion compilation changes...
                //this.Labels.Remove(grdCell);
                ((PathNode)((Node)this)).Labels.Remove(grdCell);
			}

			if (grdCell.OldColumnSpan != grdCell.ColSpan)
			{
				if (grdCell.ColSpan != 1)
				{
					return false;
				}
				float xPos = grdCell.ColumnIndex * 50;
				for (int i = 0; i < grdCell.OldColumnSpan; i++)
				{
                    //Syncfusion compilation changes...
                    //float ctrlWidth = grdCell.Width / grdCell.OldColumnSpan;
                    //float ctrlHeight = grdCell.Height;// / grdCell.RowSpan;
                    float ctrlWidth = grdCell.Size.Width / grdCell.OldColumnSpan;
                    float ctrlHeight = grdCell.Size.Height;// / grdCell.RowSpan;

					float yPos = grdCell.RowIndex * 20;

					int index = 0;
					//for (int iCol = grdCell.ColumnIndex; iCol < grdCell.ColumnIndex + grdCell.OldColumnSpan; iCol++)
					//{
					//yPos = grdCell.RowIndex * 20;
					//for (int iRow = grdCell.RowIndex; iRow < grdCell.RowSpan; iRow++)
					//{


					GridCell cellCtrl = new GridCell();

                    //Syncfusion compilation changes...
                    //cellCtrl.GridCellClick +=new NodeMouseEventHandler(cellCtrl_GridCellClick);
                    //this.Labels.Add(cellCtrl);
                    //cellCtrl.Anchor = BoxPosition.TopLeft;
                    ((PathNode)((Node)this)).Labels.Add(cellCtrl);
                    cellCtrl.Position = Position.TopLeft;

					cellCtrl.OffsetX = xPos + ctrlWidth / 2;
					cellCtrl.OffsetY = yPos + ctrlHeight / 2 + _topLabelHeight;
					cellCtrl.ReadOnly = false;
					cellCtrl.RowIndex = grdCell.RowIndex;
					cellCtrl.ColumnIndex = grdCell.ColumnIndex + i;
                    
                    //Syncfusion compilation changes...
                    //cellCtrl.BorderStyle.ShowBorder = true;
                    //cellCtrl.BorderStyle.BorderColor = Color.DimGray;

				//	cellCtrl.WrapText = false;
                    
                    //Syncfusion compilation changes...
                    //cellCtrl.Width = ctrlWidth;
                    //cellCtrl.Height = ctrlHeight;
					cellCtrl.RowSpan = grdCell.RowSpan;
					cellCtrl.ColSpan = grdCell.ColSpan;
					cellCtrl.OldRowSpan = grdCell.RowSpan;
					cellCtrl.OldColumnSpan = grdCell.ColSpan;
					cellCtrl.ColumnSpanChanged +=new EventHandler(grdCell_ColumnSpanChanged);
					cellCtrl.RowSpanChanged +=new EventHandler(grdCell_RowSpanChanged);
					xPos = xPos + ctrlWidth;
					index++;
					//}
					//xPos = xPos + ctrlWidth;
					//}
					_gridlineColor = Color.DimGray;
					_gridBorderWidth = 1;
					_gridCellFont = 12;
				}
                //Syncfusion compilation changes...
                //this.Labels.Remove(grdCell);
                ((PathNode)((Node)this)).Labels.Remove(grdCell);
			}
			return true;
		}

		void grdCell_RowSpanChanged(object sender, EventArgs e)
		{
			//try
			//{
			GridCell grdCell = sender as GridCell;
			if (grdCell.OldRowSpan < grdCell.RowSpan)
			{
				bool success = MergeVertical(grdCell);
				if (!success)
				{
					grdCell.ResetRowSpan();

					//grdCell.RowSpan = grdCell.OldRowSpan;
				}
				else
				{
					grdCell.OldRowSpan = grdCell.RowSpan;
				}
			}
			else
			{
				//	grdCell.RowSpan = grdCell.OldRowSpan;
				bool success = UnMergeVertical(grdCell);
				if (!success)
				{
					grdCell.ResetRowSpan();
					//grdCell.RowSpan = grdCell.OldRowSpan;
				}
				else
				{
					grdCell.OldRowSpan = grdCell.RowSpan;
				}
			}
            //Syncfusion compilation changes...
            //if (_model != null)
            //{
            //    _model.UpdateViews();
            //}

			//}
			//catch (Exception)
			//{


			//}

		}


		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
			if (this.SelectedCell != null)
			{
                //Syncfusion compilation changes...
                //this.SelectedCell.BorderStyle.BorderWidth = _oldBoderWidth;
                //this.SelectedCell.BorderStyle.BorderColor = _oldColor;
                //this.SelectedCell.BorderStyle.ShowBorder = _oldIsVisible;
			}
			info.AddValue("_gridlineColor", this._gridlineColor);
			info.AddValue("_gridBorderWidth", this._gridBorderWidth);
			info.AddValue("_colWidth", this._colWidth);
			info.AddValue("_showGridlines", this._showGridlines);
			info.AddValue("_cols", this._cols);
			info.AddValue("_rows", this._rows);
			info.AddValue("_topLabelHeight", this._topLabelHeight);
			info.AddValue("_gridCellFont", this._gridCellFont);
			
			info.AddValue("_gridCellFontFamily", this._gridCellFontFamily);
			info.AddValue("_cellsForeColor", this._cellsForeColor);
			info.AddValue("_cellsBackColor", this._cellsBackColor);
            //info.AddValue("_totalColumns", this._totalColumns);
            //info.AddValue("_totalRows", this._totalRows);

		}

		#endregion

		#region Private Methods

        //Syncfusion compilation changes...
        //protected override void OnBoundsChanged(BoundsEventArgs evtArgs)
        //{
        //    base.OnBoundsChanged(evtArgs);
        //    ChangeBounds();
        //}

		private void ChangeBounds()
		{
			for (int j = this.Ports.Count; j > 0; j--)
			{
				this.Ports.Remove(this.Ports[j - 1]);
			}

			float xOffset = this.X;
			float yOffset = this.Y;
			int nRows = this.Rows;
			int nCols = this.Columns;
			float rSpan = 0;
			float cSpan = 0;
			bool firstRow = false;
            //Syncfusion compilation changes...
            //float heightAdd = (this.Height - this.HeaderCell.Height) / nRows;
            //float headerHeight = this.HeaderCell.Height;
            float heightAdd = (this.Size.Height - this.HeaderCell.Size.Height) / nRows;
            float headerHeight = this.HeaderCell.Size.Height;

			for (int row = 0; row < nRows + 2; row++)
			{

				if (row == 0)
				{
					rSpan = 0;
					headerHeight = 0;
				}
				else
				{
                    //Syncfusion compilation changes...
                    //headerHeight = this.HeaderCell.Height;
                    headerHeight = this.HeaderCell.Size.Height;
				}

				cSpan = 0;
				for (int col = 0; col < nCols + 1; col++)
				{
					if ((row == 0) || (row == nRows + 1))
					{
                        //Syncfusion compilation changes...

                        //PointF ptworld = new PointF(xOffset + cSpan, this.Location.Y + rSpan + headerHeight);
                        //PointF[] pts = new PointF[] { ptworld };
                        //Matrix worldxform = this.WorldTransform;
                        //worldxform.Invert();
                        //worldxform.TransformPoints(pts);
                        //CirclePort cPort = new CirclePort(pts[0]);
                        //this.Ports.Add(cPort);
                        PointF ptworld = new PointF(xOffset + cSpan, this.PinPoint.Y + rSpan + headerHeight);
                        PointF[] pts = new PointF[] { ptworld };
                        Matrix worldxform = new Matrix();
                        worldxform.Invert();
                        worldxform.TransformPoints(pts);
                        ConnectionPoint cPort = new ConnectionPoint();
                        cPort.VisualType = PortVisualType.CirclePort;
                        cPort.OffsetX = pts[0].X;
                        cPort.OffsetY = pts[0].Y;
                        this.Ports.Add(cPort);
					}
					else
					{
						if ((col == 0) || (col == nCols))
						{
                            //Syncfusion compilation changes...

                            //PointF ptworld = new PointF(xOffset + cSpan, this.Location.Y + rSpan + headerHeight);
                            //PointF[] pts = new PointF[] { ptworld };
                            //Matrix worldxform = this.WorldTransform;
                            //worldxform.Invert();
                            //worldxform.TransformPoints(pts);
                            //CirclePort cPort = new CirclePort(pts[0]);
                            //this.Ports.Add(cPort);
                            PointF ptworld = new PointF(xOffset + cSpan, this.PinPoint.Y + rSpan + headerHeight);
                            PointF[] pts = new PointF[] { ptworld };
                            Matrix worldxform = new Matrix();
                            worldxform.Invert();
                            worldxform.TransformPoints(pts);
                            ConnectionPoint cPort = new ConnectionPoint();
                            cPort.VisualType = PortVisualType.CirclePort;
                            cPort.OffsetX = pts[0].X;
                            cPort.OffsetY = pts[0].Y;
                            this.Ports.Add(cPort);
						}
					}
                    //Syncfusion compilation changes...
                    //cSpan = cSpan + (this.Width / nCols);
                    cSpan = cSpan + (this.Size.Width / nCols);
				}
				if (row != 0)
					rSpan = rSpan + heightAdd;
			}
		}

		private void AddHeader()
		{
			GridHeaderCell toplbl = new GridHeaderCell();
            //Syncfusion compilation changes...
            //this.Labels.Add(toplbl);
            //toplbl.Anchor = BoxPosition.TopLeft;
            ((PathNode)((Node)this)).Labels.Add(toplbl);
            toplbl.Position = Position.TopLeft;

            //toplbl.OffsetX = this.outerRect.Width / 2; //Syncfusion compilation changes...
			toplbl.OffsetY = _topLabelHeight / 2;
			toplbl.BackgroundStyle.Color = Color.LightGray;
            //Syncfusion compilation changes...
            //toplbl.FillStyle.Color = Color.Blue;
            //toplbl.BorderStyle.ShowBorder = true;

			toplbl.Text = "Header";
            //Syncfusion compilation changes...
            //toplbl.Width = this.outerRect.Width;
            //toplbl.Height = _topLabelHeight;
            //toplbl.HeaderCellClick +=new NodeMouseEventHandler(cellCtrl_GridCellClick);
			toplbl.FontStyle.Bold = true;
			toplbl.FontStyle.PointSize = 10f;
			toplbl.HorizontalAlignment = StringAlignment.Center;
			toplbl.VerticalAlignment = StringAlignment.Center;
            //Syncfusion compilation changes...
            //toplbl.BorderStyle.BorderWidth = 2;
            //toplbl.BorderStyle.BorderColor = Color.Maroon;
            //toplbl.FillStyle.Color = Color.MidnightBlue;
			_headerCell = toplbl;
		}

		//public bool MergeCells(ArrayList GridCellList)
		//{
		//   int currentColSpan =0,oldColSpan=0,currentRowSpan=0,oldRowSpan=0,colIndex=0,rowIndex=0,flag;
		//   float width=0,height=0,LocX=0,LocY=0;
		//   if(GridCellList!=null||GridCellList.Count>0)
		//   {
		//      int gridColSpan=0,gridRowSpan=0;
		//      for(int i=0;i<GridCellList.Count;i++)
		//      {
		//         GridCell lbl = GridCellList[i] as GridCell;	
		//         if(i==0)
		//         {
		//            LocX= lbl.OffsetX;
		//            LocY=lbl.OffsetY;
		//            colIndex=lbl.ColumnIndex;
		//            rowIndex=lbl.RowIndex;
		//            width = lbl.Width;
		//            height = lbl.Height;						
		//         }					

		//         currentColSpan = lbl.ColumnIndex+1;
		//         currentRowSpan=lbl.RowIndex+1;
		//         if(currentColSpan>oldColSpan)
		//         {
		//            gridColSpan=currentColSpan;
		//            oldColSpan=currentColSpan; 
		//         }
		//         if(currentRowSpan>oldRowSpan)
		//         {
		//            gridRowSpan=currentRowSpan;
		//            oldRowSpan=gridRowSpan;
		//         }					
		//      }
		//      //remove the cells from the grid
		//      for(int i=0;i<GridCellList.Count;i++)
		//      {
		//         GridCell lbl = GridCellList[i] as GridCell;
		//         this.Labels.Remove(lbl);
		//      } 

		//      #region [Adding New Grid Cell After Merge]
		//       width = width*gridColSpan;
		//      height = height*gridRowSpan;
		//      //AddGridCells(LocX,LocY,height,width,colIndex,rowIndex,flag);
		//      float setX = (float)12.50;
		//      float setY =5;

		//      float ctrlWidth = width;
		//      float ctrlHeight = height;
		//      float xPos = LocX;
		//      float yPos = LocY;
		//      float index = 0;
		//      GridCell cellCtrl = new GridCell();
		//      cellCtrl.GridCellClick+=new NodeMouseEventHandler(cellCtrl_GridCellClick);
		//      cellCtrl.ColumnSpanChanged +=new EventHandler(grdCell_ColumnSpanChanged);
		//      cellCtrl.RowSpanChanged +=new EventHandler(grdCell_RowSpanChanged);
		//      this.Labels.Add(cellCtrl);
		//      cellCtrl.Anchor	= BoxPosition.TopLeft;
		//      if(gridColSpan==gridRowSpan)
		//      {
		//            cellCtrl.OffsetX = xPos+ setX*gridColSpan;
		//            //cellCtrl.OffsetX = (xPos*(float)((float)(gridColSpan)/2)+setX*gridColSpan);
		//            cellCtrl.OffsetY = yPos + setY*gridRowSpan;


		//      }
		//      else if(gridColSpan>gridRowSpan)
		//      {
		//            cellCtrl.OffsetX = (xPos*(float)((float)(gridColSpan)/2)+setX*gridColSpan);
		//            cellCtrl.OffsetY = yPos ;

		//      }
		//      else
		//      {
		//         cellCtrl.OffsetX = xPos;					 
		//          //cellCtrl.OffsetY = yPos+ setY*gridRowSpan;
		//         cellCtrl.OffsetY = (yPos*(float)((float)(gridRowSpan)/((float)gridRowSpan/(float)2))+setY*gridRowSpan);
		//      }  
		//      cellCtrl.ReadOnly = false;
		//      cellCtrl.RowIndex = rowIndex;
		//      cellCtrl.ColumnIndex =colIndex;
		//      cellCtrl.BorderStyle.ShowBorder = true;
		//      cellCtrl.BorderStyle.BorderColor = Color.DimGray;
		//      cellCtrl.WrapText = false;
		//      cellCtrl.Width = ctrlWidth;
		//      cellCtrl.Height = ctrlHeight;
		//      //xPos = xPos + ctrlWidth;	     
		//      _gridlineColor = Color.DimGray;
		//      _gridBorderWidth = 1;
		//      _gridCellFont = 12;

		//      #endregion [Adding New Grid Cell After Merge]
		//      return true;
		//   }
		//   return true;

		//}

		//private void AddGridCells(float LocX,float LocY,float height,float width,int colIndex,int rowIndex,int flag)
		//{ 	
		//   float setX = (float)12.50;
		//   float setY =5;

		//   float ctrlWidth = width;
		//   float ctrlHeight = height;
		//   float xPos = LocX;
		//   float yPos = LocY;
		//   float index = 0;
		//   GridCell cellCtrl = new GridCell();
		//   cellCtrl.GridCellClick+=new NodeMouseEventHandler(cellCtrl_GridCellClick);
		//   cellCtrl.ColumnSpanChanged +=new EventHandler(grdCell_ColumnSpanChanged);
		//   cellCtrl.RowSpanChanged +=new EventHandler(grdCell_RowSpanChanged);
		//   this.Labels.Add(cellCtrl);
		//   cellCtrl.Anchor	= BoxPosition.TopLeft;
		//   //cellCtrl.OffsetX = xPos;
		//   //cellCtrl.OffsetY = yPos;
		//   switch(flag)
		//   {
		//      case 0:
		//         cellCtrl.OffsetX = xPos+ _topLabelWidth;
		//         cellCtrl.OffsetY = yPos + 10;
		//         break;
		//      case 1:
		//         cellCtrl.OffsetX = xPos+_topLabelWidth;
		//         cellCtrl.OffsetY = yPos ;
		//         break;
		//      case 2:	
		//         cellCtrl.OffsetX = xPos;
		//         cellCtrl.OffsetY = yPos + 10;

		//         break;
		//   } 

		//   cellCtrl.ReadOnly = false;
		//   cellCtrl.RowIndex = rowIndex;
		//   cellCtrl.ColumnIndex =colIndex;
		//   cellCtrl.BorderStyle.ShowBorder = true;
		//   cellCtrl.BorderStyle.BorderColor = Color.DimGray;
		//   cellCtrl.WrapText = false;
		//   cellCtrl.Width = ctrlWidth;
		//   cellCtrl.Height = ctrlHeight;
		//   cellCtrl.RowSpan = 1;
		//   cellCtrl.ColSpan = 1;
		//   //xPos = xPos + ctrlWidth;	     
		//   _gridlineColor = Color.DimGray;
		//   _gridBorderWidth = 1;
		//   _gridCellFont = 12;

		//}
        
        //Syncfusion compilation changes...
        //private void AddGridCells()
        //{
        //    float ctrlWidth = (float)this.outerRect.Width / this.Columns;
        //    float ctrlHeight = (float)this.outerRect.Height / this.Rows;
        //    float xPos = 0;
        //    float yPos = 0;
        //    int index = 0;
        //    for (int iRow = 0; iRow < this.Rows; iRow++)
        //    {
        //        xPos = 0;
        //        for (int iCol = 0; iCol < this.Columns; iCol++)
        //        {
        //            GridCell cellCtrl = new GridCell();
        //            cellCtrl.GridCellClick +=new NodeMouseEventHandler(cellCtrl_GridCellClick);
        //            cellCtrl.ColumnSpanChanged +=new EventHandler(grdCell_ColumnSpanChanged);
        //            cellCtrl.RowSpanChanged +=new EventHandler(grdCell_RowSpanChanged);
        //            this.Labels.Add(cellCtrl);
        //            cellCtrl.Anchor = BoxPosition.TopLeft;
        //            cellCtrl.OffsetX = xPos + ctrlWidth / 2;
        //            cellCtrl.OffsetY = yPos + ctrlHeight / 2 + _topLabelHeight;
        //            cellCtrl.ReadOnly = false;
        //            cellCtrl.RowIndex = iRow;
        //            cellCtrl.ColumnIndex = iCol;
        //            cellCtrl.BorderStyle.ShowBorder = true;
        //            cellCtrl.BorderStyle.BorderColor = Color.DimGray;
        //            //cellCtrl.WrapText = false;
        //            cellCtrl.Width = ctrlWidth;
        //            cellCtrl.Height = ctrlHeight;
        //            cellCtrl.OldRowSpan = 1;
        //            cellCtrl.OldColumnSpan = 1;
        //            cellCtrl.RowSpan = 1;
        //            cellCtrl.ColSpan = 1;
        //            xPos = xPos + ctrlWidth;
        //            index++;
        //        }
        //        yPos = yPos + ctrlHeight;
        //    }
        //    _gridlineColor = Color.DimGray;
        //    _gridBorderWidth = 1;
        //    _gridCellFont = 12;

        //}

		private void SetPropertyTable()
		{
			if (PT == null)
			{
				try
				{
					PropertyInfo[] properties = this.GetType().GetProperties(BindingFlags.Instance | BindingFlags.DeclaredOnly | BindingFlags.Public);

					foreach (PropertyInfo property in properties)
					{
						BrowsableAttribute[] attr = property.GetCustomAttributes(typeof(BrowsableAttribute), false) as BrowsableAttribute[];
						if (attr.Length > 0)
							if (((BrowsableAttribute)attr[0]).Browsable == false)
								continue;
						string propname = property.Name;
						if (property.Name == "MasterPlantItem")
						{
                            //Syncfusion compilation changes...
                            //PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "Binding Information", "Lists of Master Plant Item", this.GetPropertyValue(property.Name), "", typeof(SymbolTypeConverter), this));
						}
						else if (property.Name == "PlantItem")
						{
                            //Syncfusion compilation changes...
                            //PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "Binding Information", "Lists the Plant Item objects of Selected Master Plant Item", this.GetPropertyValue(property.Name), "", typeof(ObjectNameConverter), this));
						}
						else if (property.Name == "Link")
						{
                            //Syncfusion compilation changes...
                            //PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "Link", "Select the Link for the Symbol", this.GetPropertyValue(property.Name), "", typeof(LinkTypeConverter), this));
						}
						else
						{
							string catagory = "";
							CategoryAttribute[] catAttrib = property.GetCustomAttributes(typeof(CategoryAttribute), true) as CategoryAttribute[];
							if (catAttrib.Length > 0)
								catagory = catAttrib[0].Category;
							else
								catagory = "General Properties";
							TypeConverterAttribute[] typCnvtAttr = property.GetCustomAttributes(typeof(TypeConverterAttribute), false) as TypeConverterAttribute[];
                            string typeConverter = "";
                            if (typCnvtAttr.Length > 0)
                                typeConverter = ((TypeConverterAttribute)typCnvtAttr[0]).ConverterTypeName;
                            //Syncfusion compilation changes...
                            //PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, catagory, "Sets the " + property.Name + " property of selected symbol", this.GetPropertyValue(property.Name), "", typeConverter, this));
							
                            //PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, catagory, "Sets the " + property.Name + " property of selected symbol", this.GetPropertyValue(property.Name), "", "", this));
						}
					}
				}
				catch (Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}


		private void ChangeRows(int rows)
		{
            //Syncfusion compilation changes...
            //GridCell lastGridCell = this.Labels[this.Labels.Count - 1] as GridCell;
            GridCell lastGridCell = ((PathNode)((Node)this)).Labels[((PathNode)((Node)this)).Labels.Count - 1] as GridCell;

			int currentRows = lastGridCell.RowIndex + 1;
			int diffinRows = rows - currentRows;
			if (diffinRows < 0)
			{
				RemoveRows(rows);
			}
			else
			{
				AddRows(rows);
			}
			ChangeBounds();
		}


		private void AddRows(int rows)
		{
			GridCell lastGridCell = GetGridCellForRowColIndex(this._oldRows - 1, this._cols - 1);
			int currentRows = this._oldRows;//lastGridCell.RowIndex + 1;
			int diffinRows = rows - currentRows;
			float ctrlWidth = 50;//lastGridCell.Width;
			float ctrlHeight = 20;//lastGridCell.Height;
			int currentCols = this._cols;
            //Syncfusion compilation changes...
            //float yPos = this.Height;
            //float oldyPos = this.Height;

			float xPos = 0;
			//this.Height = this.Height + ctrlHeight * diffinRows;//((this.Height-_topLabelHeight)/currentRows) * diffinRows;
            this._rows -= diffinRows;
            float cellCtrlHeight = 0;
			for (int iRow = 0; iRow < diffinRows;)
			{
                GridCell lastGridCellInCurrColumn = lastGridCell;
				xPos = 0;
                float yPos = 0;//Syncfusion compilation changes...
                cellCtrlHeight = 0;
				for (int icols = 0; icols < (this.Columns); icols++)
				{
                    lastGridCellInCurrColumn = GetGridCellForRowColIndex(currentRows - 1, icols);
					GridCell cellCtrl = new GridCell();
                    //Syncfusion compilation changes...
                    //cellCtrl.GridCellClick +=new NodeMouseEventHandler(cellCtrl_GridCellClick);

                    ((PathNode)((Node)this)).Labels.Add(cellCtrl);//this.Labels.Add(cellCtrl);//Syncfusion compilation changes...
					//float previousCellWidth = GetGridCellForRowColIndex(currentRows - 1, icols).Width;
                    cellCtrl.Position = Position.TopLeft;//cellCtrl.Anchor = BoxPosition.TopLeft; //Syncfusion compilation changes...
                    //Syncfusion compilation changes...
                    //cellCtrl.OffsetX = xPos + (lastGridCellInCurrColumn.Width / lastGridCellInCurrColumn.ColSpan) / 2;
                    cellCtrl.OffsetX = xPos + (lastGridCellInCurrColumn.Size.Width / lastGridCellInCurrColumn.ColSpan) / 2;
                    cellCtrl.OffsetY = yPos + ctrlHeight * (lastGridCell.RowSpan)/2;
					cellCtrl.ReadOnly = true;
					cellCtrl.RowIndex =iRow + lastGridCell.RowIndex + lastGridCell.RowSpan;
					cellCtrl.ColumnIndex = icols;
                    //Syncfusion compilation changes...
                    //cellCtrl.BorderStyle.ShowBorder = this.ShowGridLines;
                    //cellCtrl.BorderStyle.BorderColor = _gridlineColor;
                    //cellCtrl.BorderStyle.BorderWidth = _gridBorderWidth;
					cellCtrl.FontFamily = _gridCellFontFamily;
					cellCtrl.BackgroundStyle.Color = _cellsBackColor;
                    //Syncfusion compilation changes...
                    //cellCtrl.FillStyle.Color = _cellsForeColor;
					cellCtrl.FontSize = _gridCellFont;
					//cellCtrl.WrapText = false;
                    //Syncfusion compilation changes...
                    //cellCtrl.Width = lastGridCellInCurrColumn.Width / lastGridCellInCurrColumn.ColSpan;
                    //cellCtrl.Height = ctrlHeight * lastGridCell.RowSpan;
					cellCtrl.RowSpan = lastGridCell.RowSpan;
					cellCtrl.ColSpan =1; //lastGridCell.ColSpan;
					cellCtrl.OldRowSpan = lastGridCell.RowSpan;
					cellCtrl.OldColumnSpan = 1;//lastGridCell.ColSpan;
                    //Syncfusion compilation changes...
                    //xPos = xPos + (lastGridCellInCurrColumn.Width/lastGridCellInCurrColumn.ColSpan);
                    xPos = xPos + (lastGridCellInCurrColumn.Size.Width / lastGridCellInCurrColumn.ColSpan);

                    cellCtrl.ColumnSpanChanged += new EventHandler(grdCell_ColumnSpanChanged);
                    cellCtrl.RowSpanChanged += new EventHandler(grdCell_RowSpanChanged);
                    //Syncfusion compilation changes...
                    //cellCtrlHeight = cellCtrl.Height;
				}
                float oldyPos = yPos;//oldyPos = yPos; //Syncfusion compilation changes...
                yPos = yPos + cellCtrlHeight;
                iRow += lastGridCell.RowSpan;

                this._rows += (lastGridCell.RowSpan);
			}
            GridHeaderCell grdHeader = GetHeaderCell();
            //this._oldRows += lastGridCell.RowSpan;
            //Syncfusion compilation changes...
            //this.Height = oldyPos + grdHeader.Height + ctrlHeight * (lastGridCell.RowSpan-1);
			ChangeBounds();
		}


		private void RemoveRows(int rows)
		{
            //Syncfusion compilation changes...
            LabelCollection labels = ((PathNode)((Node)this)).Labels;
            //GridCell lastGridCell = this.Labels[this.Labels.Count - 1] as GridCell;
            GridCell lastGridCell = labels[labels.Count - 1] as GridCell;
			int currentRows = lastGridCell.RowIndex + lastGridCell.RowSpan;
			int diffinRows = currentRows - rows;
			int currentCols = this._cols;
			float reducedHeight = 0;
			for (int iRow = diffinRows; iRow > 0; iRow--)
			{
				for (int icols = this.Columns; icols > 0; icols--)
				{
					GridCell cellCtrl = this.GetGridCellForRowColIndex(currentRows - iRow, icols - 1);
                    if (cellCtrl != null)
                    {
                        if (cellCtrl.RowSpan > 1)
                        {
                            cellCtrl.RowSpan = 1;
                            cellCtrl = this.GetGridCellForRowColIndex(currentRows - iRow, icols - 1);
                        }
                        //Syncfusion compilation changes...
                        //cellCtrl.GridCellClick -= new NodeMouseEventHandler(cellCtrl_GridCellClick);
                        cellCtrl.ColumnSpanChanged -= new EventHandler(grdCell_ColumnSpanChanged);
                        cellCtrl.RowSpanChanged -= new EventHandler(grdCell_RowSpanChanged);
                        if (GridCellRemoved != null && cellCtrl.IsBinded)
                            GridCellRemoved(cellCtrl, new EventArgs());
                        //Syncfusion compilation changes...
                        //reducedHeight = cellCtrl.Height;
                        //this.Labels.Remove(cellCtrl);
                        labels.Remove(cellCtrl);
                    }
				}
			}
            //Syncfusion compilation changes...
            //lastGridCell = this.Labels[this.Labels.Count - 1] as GridCell;
            lastGridCell = labels[labels.Count - 1] as GridCell;
            //this.Height = lastGridCell.OffsetY + lastGridCell.Height/2;
            //if (_model != null)
            //    _model.UpdateViews();
			ChangeBounds();
		}



		public bool RemoveRow()
		{
			bool success = false;
			if (this.SelectedCell != null && this._rows > 0)
			{
				int rowindex = this.SelectedCell.RowIndex;
				//GridCell selectedGrdCell = this.SelectedCell;
                //Syncfusion compilation changes...
                //float reducedHeight = this.SelectedCell.Height;
                float reducedHeight = this.SelectedCell.Size.Height;
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //for (int i = this.Labels.Count - 1; i > 0; i--)
                for (int i = labels.Count - 1; i > 0; i--)
				{
                    //Syncfusion compilation changes...
                    //GridCell grdCell = this.Labels[i] as GridCell;
                    GridCell grdCell = labels[i] as GridCell;
					if ((grdCell.RowIndex + grdCell.RowSpan - 1 == rowindex) || (grdCell.RowIndex == rowindex && grdCell.RowSpan > 1))
					{
						if (grdCell.RowSpan > 1)
							return false;
					}
				}
				//for (int i = this.Labels.Count; i > 0; i--)
				//{
				//   if (i == 1)
				//      continue;
				//   else
				//   {

				//      GridCell currentGridCell = this.Labels[i - 1] as GridCell;
				//      if (currentGridCell.ColumnIndex > selectedGrdCell.ColumnIndex && currentGridCell.ColumnIndex <= selectedGrdCell.ColumnIndex + selectedGrdCell.ColSpan - 1 && currentGridCell.RowIndex < selectedGrdCell.RowIndex && currentGridCell.RowIndex + currentGridCell.RowSpan > selectedGrdCell.RowIndex)
				//      {
				//         return false;
				//      }
				//      if (currentGridCell.ColumnIndex > selectedGrdCell.ColumnIndex && currentGridCell.ColumnIndex <= selectedGrdCell.ColumnIndex + selectedGrdCell.ColSpan - 1 && (currentGridCell.RowIndex >= selectedGrdCell.RowIndex && currentGridCell.RowIndex < selectedGrdCell.RowIndex + selectedGrdCell.RowSpan) )
				//      {
				//         if (currentGridCell.RowIndex + currentGridCell.RowSpan > selectedGrdCell.RowIndex + selectedGrdCell.RowSpan)
				//         {
				//            return false;
				//         }
				//      }
				//   }
				//}
                //Syncfusion compilation changes...
                //for (int i = this.Labels.Count - 1; i > 0; i--)
                for (int i = labels.Count - 1; i > 0; i--)
				{
                    //Syncfusion compilation changes...
                    //GridCell grdCell = this.Labels[i] as GridCell;
                    GridCell grdCell = labels[i] as GridCell;
					if (grdCell.RowIndex == rowindex)
					{
                        //Syncfusion compilation changes...
                        //grdCell.GridCellClick -= new NodeMouseEventHandler(cellCtrl_GridCellClick);
						grdCell.ColumnSpanChanged -=new EventHandler(grdCell_ColumnSpanChanged);
						grdCell.RowSpanChanged -=new EventHandler(grdCell_RowSpanChanged);
						if (GridCellRemoved != null && grdCell.IsBinded)
							GridCellRemoved(grdCell, new EventArgs());
                        //Syncfusion compilation changes...
                        //this.Labels.Remove(grdCell);
                        labels.Remove(grdCell);

					}
					if (grdCell.RowIndex > rowindex)
					{
						grdCell.OffsetY = grdCell.OffsetY - reducedHeight;
						grdCell.RowIndex = grdCell.RowIndex - 1;
					}
				}
                //Syncfusion compilation changes...
                //this.Height = this.Height - reducedHeight;
				this._rows = _rows - 1;
				success = true;
                //Syncfusion compilation changes...
                //if (_model != null)
                //    _model.UpdateViews();
			}
			ChangeBounds();
			return success;
		}

        //Syncfusion compilation changes...
        //private void ChangeColumns(int cols)
        //{						  
        //    GridCell lastGridCell = this.Labels[this.Labels.Count - 1] as GridCell;
        //    int currentCols = lastGridCell.ColumnIndex + lastGridCell.ColSpan;//+1;
        //    int diffinCols = cols - currentCols;
        //    if (diffinCols < 0)
        //    {
        //        RemoveColumns(cols);
        //    }
        //    else
        //    {
        //        AddColumns(cols);
        //    }
        //    ChangeBounds();
        //}


        //private void AddColumns(int cols)
        //{
        //    GridCell lastGridCell = GetGridCellForRowColIndex(this._rows - 1, this._oldCols - 1);//this.Labels[this.Labels.Count-1] as GridCell;
        //    float ctrlWidth = lastGridCell.Width/lastGridCell.ColSpan;//lastGridCell.Width;
        //    float ctrlHeight = lastGridCell.Height/lastGridCell.RowSpan;//lastGridCell.Height;
        //    int currentCols = this._oldCols;// lastGridCell.ColumnIndex + 1;//lastGridCell.ColSpan;
        //    int diffinCols = cols - currentCols;
        //    int currentRows = this._rows;
        //    float yPos = _topLabelHeight;
        //    float xPos = this.Width;
        //    float changedWidth = xPos;

        //    GridCell lastGridCellInCurrRow = lastGridCell;
        //    //this.Width = this.Width + (this.GridBorderWidth - 2) + ctrlWidth * diffinCols;
        //    GridCell currGridCell = lastGridCell;
        //    this._cols -= diffinCols;
        //    for (int icols = 0; icols < diffinCols;)
        //    {
               
        //        yPos = _topLabelHeight;
        //        for (int iRows = 0; iRows < (this.Rows); iRows++)
        //        {
        //            lastGridCellInCurrRow = GetGridCellForRowColIndex(iRows, currentCols - 1);

        //            GridCell cellCtrl = new GridCell();
        //            currGridCell = cellCtrl;
        //            cellCtrl.GridCellClick +=new NodeMouseEventHandler(cellCtrl_GridCellClick);
        //            //cellCtrl.ColumnSpanChanged +=new EventHandler(grdCell_ColumnSpanChanged);
        //            //cellCtrl.RowSpanChanged +=new EventHandler(grdCell_RowSpanChanged);
        //            this.Labels.Add(cellCtrl);
        //            //float previouscellHeight = GetGridCellForRowColIndex(iRows, currentCols - 1).Height;
        //            cellCtrl.Anchor = BoxPosition.TopLeft;
        //            cellCtrl.OffsetX = xPos + (ctrlWidth*lastGridCell.ColSpan)/2;
        //            cellCtrl.OffsetY = yPos + (lastGridCellInCurrRow.Height / lastGridCellInCurrRow.RowSpan) / 2;// previouscellHeight / 2;
        //            cellCtrl.ReadOnly = true;
        //            cellCtrl.RowIndex = iRows;
        //            cellCtrl.ColumnIndex = icols + lastGridCell.ColumnIndex + lastGridCell.ColSpan;
        //            cellCtrl.BorderStyle.ShowBorder = this.ShowGridLines;
        //            cellCtrl.BorderStyle.BorderColor = _gridlineColor;
        //            cellCtrl.BorderStyle.BorderWidth = _gridBorderWidth;
        //            cellCtrl.FontSize = _gridCellFont;
        //            cellCtrl.FontFamily = _gridCellFontFamily;
        //            cellCtrl.BackgroundStyle.Color = _cellsBackColor;
        //            cellCtrl.FillStyle.Color = _cellsForeColor;
        //            //cellCtrl.WrapText = false;
        //            cellCtrl.Width = ctrlWidth * lastGridCell.ColSpan;
        //            cellCtrl.Height = lastGridCellInCurrRow.Height/lastGridCellInCurrRow.RowSpan;

        //            cellCtrl.RowSpan = 1;//lastGridCell.RowSpan;
        //            cellCtrl.ColSpan = lastGridCell.ColSpan;
        //            cellCtrl.OldRowSpan = 1;//lastGridCell.RowSpan;
        //            cellCtrl.OldColumnSpan = lastGridCell.ColSpan;
        //            cellCtrl.ColumnSpanChanged +=new EventHandler(grdCell_ColumnSpanChanged);
        //            cellCtrl.RowSpanChanged +=new EventHandler(grdCell_RowSpanChanged);
        //            yPos = yPos + lastGridCellInCurrRow.Height / lastGridCellInCurrRow.RowSpan;

                    
        //        }
        //        this._cols += lastGridCell.ColSpan;
        //        icols += lastGridCell.ColSpan;
        //        xPos = xPos + (lastGridCellInCurrRow.Width * lastGridCell.ColSpan);
        //    }
        //    this.Width = currGridCell.Width / 2 + currGridCell.OffsetX;
        //    changedWidth = xPos - changedWidth;
        //    GridHeaderCell grdHeader = GetHeaderCell();
        //    grdHeader.Width = this.Width;
        //        grdHeader.Height = this.RowHeight;

        //    grdHeader.OffsetX = grdHeader.Width / 2;

        //    ChangeBounds();
        //}

        //public bool RemoveColumn()
        //{
        //    bool success = false;
        //    if (this.SelectedCell != null && this._cols > 1)
        //    {
        //        int colIndex = this.SelectedCell.ColumnIndex;
        //        float reducedWidth = this.SelectedCell.Width;
        //        for (int i = this.Labels.Count - 1; i > 0; i--)
        //        {
        //            GridCell grdCell = this.Labels[i] as GridCell;
        //            if ((grdCell.ColumnIndex + grdCell.ColSpan - 1 == colIndex) || (grdCell.ColumnIndex == colIndex && grdCell.ColSpan > 1))
        //            {
        //                if (grdCell.ColSpan > 1)
        //                    return false;
        //            }
        //        }
        //        for (int i = this.Labels.Count - 1; i > 0; i--)
        //        {
        //            GridCell grdCell = this.Labels[i] as GridCell;
        //            if (grdCell.ColumnIndex == colIndex)
        //            {
        //                grdCell.GridCellClick -= new NodeMouseEventHandler(cellCtrl_GridCellClick);
        //                grdCell.ColumnSpanChanged -=new EventHandler(grdCell_ColumnSpanChanged);
        //                grdCell.RowSpanChanged -=new EventHandler(grdCell_RowSpanChanged);
        //                if (GridCellRemoved != null && grdCell.IsBinded)
        //                    GridCellRemoved(grdCell, new EventArgs());
        //                this.Labels.Remove(grdCell);
        //            }
        //            if (grdCell.ColumnIndex > colIndex)
        //            {
        //                grdCell.OffsetX = grdCell.OffsetX - reducedWidth;
        //                grdCell.ColumnIndex = grdCell.ColumnIndex - 1;
        //            }
        //        }
        //        this.HeaderCell.OffsetX = this.HeaderCell.OffsetX - (reducedWidth / 2);
        //        this.Width = this.Width - reducedWidth;
        //        this.HeaderCell.Width = this.Width;
        //        this._cols = _cols - 1;
        //        success = true;
        //        if (_model != null)
        //            _model.UpdateViews();
        //    }
        //    ChangeBounds();
        //    return success;
        //}

        //private void RemoveColumns(int cols)
        //{
        //    //GridCell lastGridCell = this.Labels[this.Labels.Count-1] as GridCell;
        //    GridCell lastGridCell = GetGridCellForRowColIndex(this._rows - 1, this._oldCols - 1);
        //    int currentCols = lastGridCell.ColumnIndex + lastGridCell.ColSpan;
        //    int diffinCols = currentCols - cols;
        //    int currentRows = this._rows;
        //    float reducedWidth = 0;
        //    GridHeaderCell grdHeader = GetHeaderCell();

        //    grdHeader.OffsetX = grdHeader.OffsetX - (diffinCols * lastGridCell.Width / 2);

        //    for (int iCols = diffinCols; iCols > 0; iCols--)
        //    {
        //        for (int iRows = this.Rows; iRows > 0; iRows--)
        //        {
        //            GridCell cellCtrl = this.GetGridCellForRowColIndex(iRows - 1, currentCols - iCols);
        //            if (cellCtrl != null)
        //            {
        //                if (cellCtrl.ColSpan > 1)
        //                {
        //                    cellCtrl.ColSpan = 1;
        //                    cellCtrl = this.GetGridCellForRowColIndex(iRows - 1, currentCols - iCols);
        //                }
        //                cellCtrl.GridCellClick -= new NodeMouseEventHandler(cellCtrl_GridCellClick);
        //                cellCtrl.ColumnSpanChanged -= new EventHandler(grdCell_ColumnSpanChanged);
        //                cellCtrl.RowSpanChanged -= new EventHandler(grdCell_RowSpanChanged);
        //                reducedWidth = reducedWidth + cellCtrl.Width;
        //                if (GridCellRemoved != null && cellCtrl.IsBinded)
        //                    GridCellRemoved(cellCtrl, new EventArgs());

        //                this.Labels.Remove(cellCtrl);
        //            }
        //        }
        //    }
        //    lastGridCell = GetGridCellForRowColIndex(this._rows - 1, cols - 1);

        //    this.Width = (lastGridCell.Width / 2) + lastGridCell.OffsetX;
        //    grdHeader.Width = this.Width;
        //    grdHeader.OffsetX = grdHeader.Width / 2;
        //    if (_model != null)
        //        _model.UpdateViews();
        //    ChangeBounds();

        //}

		private bool ValidateRowColumns(int count)
		{
			if (count < 1 || count > 30)
				return false;
			else
				return true;
		}

		private float ValidateDimension(float dimension)
		{
			if (dimension < 1)
				return 1;
			else
				return dimension;
		}


		private GridHeaderCell GetHeaderCell()
		{
			GridHeaderCell grdLbl = null;
            //Syncfusion compilation changes...
            LabelCollection labels = ((PathNode)((Node)this)).Labels;
            //Syncfusion compilation changes...
            //foreach (SymbolLabel lbl in this.Labels)
            foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
			{
				if (lbl.GetType() == typeof(GridHeaderCell))
				{
					grdLbl = lbl as GridHeaderCell;
					break;
				}
			}
			return grdLbl;
		}


		private GridCell GetGridCellForRowColIndex(int rowIndex, int colIndex)
		{
		   GridCell returnGC = null;
           //Syncfusion compilation changes...
           LabelCollection labels = ((PathNode)((Node)this)).Labels;
		   //foreach (SymbolLabel gc in this.Labels)
           foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
		   {
              //Syncfusion compilation changes...
              //if (gc.GetType() == typeof(GridCell))
              if (lbl is GridCell)
		      {
                 //Syncfusion compilation changes...
                 //GridCell currentGc = gc as GridCell;
                 GridCell currentGc = lbl as GridCell;
		         if ((currentGc.RowIndex <= rowIndex && currentGc.RowIndex + currentGc.RowSpan - 1 >= rowIndex && currentGc.ColumnIndex <= colIndex && currentGc.ColumnIndex + currentGc.ColSpan - 1 >= colIndex))
		         {
		            returnGC = currentGc;
		            break;

		         }
		      }
		   }
		   return returnGC;
		}


		//private GridCell GetLastGridCell()
		//{
		//   int lastRowIndex = 0;
		//   int lastColIndex = 0;
		//   foreach (SymbolLabel gc in this.Labels)
		//   {
		//      if (gc.GetType() == typeof(GridCell))
		//      {
		//         GridCell currentGc = gc as GridCell;
		//         if (lastRowIndex < currentGc.RowIndex)
		//         {
		//            lastRowIndex = currentGc.RowIndex;
		//         }
		//         if (lastColIndex < currentGc.ColumnIndex)
		//         {
		//              lastColIndex = currentGc.ColumnIndex;
		//         }
		//      }
		//   }
		//   return GetGridCellForRowColIndex(lastRowIndex,lastRowIndex);
		//}

		//private GridCell GetLastGridCellInRow(int rowIndex)
		//{
		//   int lastRowIndex = rowIndex;
		//   int lastColIndex = 0;
		//   foreach (SymbolLabel gc in this.Labels)
		//   {
		//      if (gc.GetType() == typeof(GridCell))
		//      {
		//         GridCell currentGc = gc as GridCell;
		//         //if (lastRowIndex < currentGc.RowIndex)
		//         //{
		//         //   lastRowIndex = currentGc.RowIndex;
		//         //}
		//         if (lastColIndex < currentGc.ColumnIndex)
		//         {
		//              lastColIndex = currentGc.ColumnIndex;
		//         }
		//      }
		//   }
		//   return GetGridCellForRowColIndex(lastRowIndex,lastRowIndex);
		//}

		//private GridCell GetLastGridCellInColumn(int columnIndex)
		//{
		//   int lastRowIndex = 0;
		//   int lastColIndex = columnIndex;
		//   foreach (SymbolLabel gc in this.Labels)
		//   {
		//      if (gc.GetType() == typeof(GridCell))
		//      {
		//         GridCell currentGc = gc as GridCell;
		//         if (lastRowIndex < currentGc.RowIndex)
		//         {
		//            lastRowIndex = currentGc.RowIndex;
		//         }
		//         //if (lastColIndex < currentGc.ColumnIndex)
		//         //{
		//         //     lastColIndex = currentGc.ColumnIndex;
		//         //}
		//      }
		//   }
		//   return GetGridCellForRowColIndex(lastRowIndex,lastRowIndex);
		//}



		public void ResizeColumn(float newColumnWidth)
		{
			//   RemoveColumn();
			//	ChangeBounds();
            //Syncfusion compilation changes..
            //if (this.SelectedCell.Width == newColumnWidth)
            if (this.SelectedCell.Size.Width == newColumnWidth)
			{
				return;
			}

            // Check for merged cells
            int firstCellColSpan = -1;

            //Syncfusion compilation changes..
            LabelCollection labels = ((PathNode)((Node)this)).Labels;
            //foreach (SymbolLabel lbl in this.Labels)
            foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
            {

                if (lbl.GetType() != typeof(GridHeaderCell))
                {
                    GridCell gCell = lbl as GridCell;
                    if (this.SelectedCell.ColumnIndex == gCell.ColumnIndex)
                    {
                        if (firstCellColSpan == -1)
                            firstCellColSpan = gCell.ColSpan;
                        if (firstCellColSpan != gCell.ColSpan)
                            return;
                    }
                }
            }

			float percentOffset = -1;
            //Syncfusion compilation changes..
            //float currentcolWidth = this.SelectedCell.Width;
            float currentcolWidth = this.SelectedCell.Size.Width;
			if (this.SelectedCell != null)
			{
                //Syncfusion compilation changes..
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
				{

					if (lbl.GetType() == typeof(GridHeaderCell))
					{
						percentOffset = (newColumnWidth - currentcolWidth) / 2;
                        //Syncfusion compilation changes..
                        //lbl.Width = lbl.Width + (newColumnWidth - currentcolWidth);
						lbl.OffsetX = lbl.OffsetX + percentOffset;
					}
					else
					{
						GridCell gCell = lbl as GridCell;
						if (this.SelectedCell.ColumnIndex == gCell.ColumnIndex)
						{
                            //Syncfusion compilation changes..
                            //lbl.Width = newColumnWidth;
							lbl.OffsetX = lbl.OffsetX + percentOffset;
						}
						else if (this.SelectedCell.ColumnIndex > gCell.ColumnIndex)
						{

						}
						else if (this.SelectedCell.ColumnIndex < gCell.ColumnIndex)
						{
							lbl.OffsetX = lbl.OffsetX + percentOffset * 2;
						}
					}
				}
                //Syncfusion compilation changes..
                //this.Width = this.Width + (newColumnWidth - currentcolWidth);

			}
			ChangeBounds();
		}



		public void ResizeColumn(GridCell selectedCell, float newColumnWidth)
		{
            float percentOffset = -1;
            //Syncfusion compilation changes..
            //float currentcolWidth = selectedCell.Width;
            float currentcolWidth = selectedCell.Size.Width;
            if (selectedCell != null)
            {
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
                {

                    if (lbl.GetType() == typeof(GridHeaderCell))
                    {
                        percentOffset = (newColumnWidth - currentcolWidth) / 2;
                        //Syncfusion compilation changes..
                        //lbl.Width = lbl.Width + (newColumnWidth - currentcolWidth);
                        lbl.OffsetX = lbl.OffsetX + percentOffset;
                    }
                    else
                    {
                        GridCell gCell = lbl as GridCell;
                        if (selectedCell.ColumnIndex == gCell.ColumnIndex)
                        {
                            //Syncfusion compilation changes..
                            //lbl.Width = newColumnWidth * gCell.ColSpan;
                            lbl.OffsetX = lbl.OffsetX + (percentOffset * gCell.ColSpan);
                        }
                        else if (selectedCell.ColumnIndex > gCell.ColumnIndex)
                        {
                            // lbl.OffsetX = lbl.OffsetX + percentOffset * 2;
                        }
                        else if (selectedCell.ColumnIndex < gCell.ColumnIndex)
                        {
                            lbl.OffsetX = lbl.OffsetX + (percentOffset * (gCell.ColSpan * 2));
                        }
                    }
                }
                //Syncfusion compilation changes..
                //this.Width = this.Width + (newColumnWidth - currentcolWidth);
            }
            ChangeBounds();
		}



		public void ResizeRow(float newRowHeight)
		{
            //Syncfusion compilation changes..
            //if (this.SelectedCell.Height == newRowHeight)
            if (this.SelectedCell.Size.Height == newRowHeight)
			{
				return;
			}
            
            // Check for merged cells
            int firstCellRowSpan = -1;
            //Syncfusion compilation changes..
            LabelCollection labels = ((PathNode)((Node)this)).Labels;
            //foreach (SymbolLabel lbl in this.Labels)
            foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
            {              
                if (lbl.GetType() != typeof(GridHeaderCell))
                {
                    GridCell gCell = lbl as GridCell;
                    if (this.SelectedCell.RowIndex == gCell.RowIndex)
                    {
                        if (firstCellRowSpan == -1)
                            firstCellRowSpan = gCell.RowSpan;
                        if (firstCellRowSpan != gCell.RowSpan)
                            return;
                    }
                }
            }

			float percentOffset = -1;
            //Syncfusion compilation changes..
            //float currentRowHeight = this.SelectedCell.Height;
            float currentRowHeight = this.SelectedCell.Size.Height;
			if (this.SelectedCell != null)
			{
                //Syncfusion compilation changes..
                labels = ((PathNode)((Node)this)).Labels;
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
				{

					if (lbl.GetType() == typeof(GridHeaderCell))
					{
						percentOffset = (newRowHeight - currentRowHeight) / 2;
					}
					else
					{
						GridCell gCell = lbl as GridCell;
						if (this.SelectedCell.RowIndex == gCell.RowIndex)
						{
                            //Syncfusion compilation changes..
                            //lbl.Height = newRowHeight;
							lbl.OffsetY = lbl.OffsetY + percentOffset;
						}
						else if (this.SelectedCell.RowIndex > gCell.RowIndex)
						{

						}
						else if (this.SelectedCell.RowIndex < gCell.RowIndex)
						{
							lbl.OffsetY = lbl.OffsetY + percentOffset * 2;
						}
					}
				}
                //Syncfusion compilation changes..
                //this.Height = this.Height + (newRowHeight - currentRowHeight);
			}
			ChangeBounds();
		}


		public void ResizeRow(GridCell selectedCell, float newRowHeight)
		{
            //Syncfusion compilation changes..
            //if (newRowHeight == selectedCell.Height)
            if (newRowHeight == selectedCell.Size.Height)
				return;
			float percentOffset = -1;
            //Syncfusion compilation changes..
            //float currentRowHeight = selectedCell.Height;
            float currentRowHeight = selectedCell.Size.Height;
			if (selectedCell != null)
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
				{
					if (lbl.GetType() == typeof(GridHeaderCell))
					{
						percentOffset = (newRowHeight - currentRowHeight) / 2;
					}
					else
					{
						percentOffset = (newRowHeight - currentRowHeight) / 2;
						GridCell gCell = lbl as GridCell;
						if (selectedCell.RowIndex == gCell.RowIndex)
						{
                            //Syncfusion compilation changes..
                            //lbl.Height = newRowHeight;
							lbl.OffsetY = lbl.OffsetY + percentOffset;
						}
						else if (selectedCell.RowIndex > gCell.RowIndex)
						{
                         //   lbl.OffsetY = lbl.OffsetY + percentOffset * 2;
						}
						else if (selectedCell.RowIndex < gCell.RowIndex)
						{
							lbl.OffsetY = lbl.OffsetY + percentOffset * 2;
						}
					}
				}
                //Syncfusion compilation changes..
                //this.Height = this.Height + (newRowHeight - currentRowHeight);
			}
			ChangeBounds();
		}


		public void ResizeAllColumnsWidth(float newColumnWidth)
		{
            GridHeaderCell headerCell = null;
            float totalWidth = 0;
            //Syncfusion compilation changes..
            LabelCollection labels = ((PathNode)((Node)this)).Labels;
            //foreach (SymbolLabel lbl in this.Labels)
            foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
			{
                if (lbl.GetType() == typeof(GridHeaderCell))
                {
                    headerCell = lbl as GridHeaderCell;
                    //float percentOffset = (newColumnWidth - currentcolWidth) / 2;
                    //lbl.Width = lbl.Width + (newColumnWidth - currentcolWidth);
                    //lbl.OffsetX = lbl.OffsetX + percentOffset;
                }
                else if (lbl is GridCell)
                {

                    GridCell gCell = lbl as GridCell;
                    float width = gCell.ColSpan * newColumnWidth;
                    //Syncfusion compilation changes..
                    //lbl.Width = width;
                    lbl.OffsetX = (float)((gCell.ColumnIndex + (.5 * gCell.ColSpan)) * newColumnWidth);

                    if (gCell.RowIndex == 0)
                        //Syncfusion compilation changes..
                        //totalWidth += lbl.Width;
                        totalWidth += lbl.Size.Width;


                    //ResizeColumn(lbl as GridCell, newColumnWidth);
                }
			}
            //Syncfusion compilation changes..
            //this.Width = headerCell.Width = totalWidth;
            headerCell.OffsetX = totalWidth / 2;
			ChangeBounds();
		}

		public void ResizeAllRowsHeight(float newRowHeight)
		{
            GridHeaderCell headerCell = null;
            float totalHeight = 0;
            //Syncfusion compilation changes..
            LabelCollection labels = ((PathNode)((Node)this)).Labels;
            //foreach (SymbolLabel lbl in this.Labels)
            foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
            {
                if (lbl.GetType() == typeof(GridHeaderCell))
                {
                    headerCell = lbl as GridHeaderCell;
                    //float percentOffset = (newColumnWidth - currentcolWidth) / 2;
                    //lbl.Width = lbl.Width + (newColumnWidth - currentcolWidth);
                    //lbl.OffsetX = lbl.OffsetX + percentOffset;
                }
                else if (lbl is GridCell)
                {

                    GridCell gCell = lbl as GridCell;
                    float height = gCell.RowSpan * newRowHeight;
                    //Syncfusion compilation changes..
                    //lbl.Height = height;
                    //lbl.OffsetY = headerCell.Height + (float)((gCell.RowIndex + (.5 * gCell.RowSpan)) * newRowHeight);
                    lbl.OffsetY = headerCell.Size.Height + (float)((gCell.RowIndex + (.5 * gCell.RowSpan)) * newRowHeight);

                    if (gCell.ColumnIndex == 0)
                        //Syncfusion compilation changes..
                        //totalHeight += lbl.Height;
                        totalHeight += lbl.Size.Height;


                    //ResizeColumn(lbl as GridCell, newColumnWidth);
                }
            }
            //Syncfusion compilation changes..
            //this.Height = headerCell.Height +  totalHeight;
            ChangeBounds();
		}


		#endregion

		#region Properties



		/// <summary>
		/// The X Cordinate of Symbol w.r.t the Canvas
		/// </summary>
		[Browsable(true)]
		public new float X
		{
			get
			{
                //Syncfusion compilation changes..
                //return base.X;
                return base.PinPoint.X;
			}
			set
			{
                //Syncfusion compilation changes..
                //base.X = value;
                base.PinPoint = new PointF(value, base.PinPoint.Y);
			}
		}

		/// <summary>
		/// The Y Cordinate of Symbol w.r.t the Canvas
		/// </summary>
		[Browsable(true)]
		public new float Y
		{
			get
			{
                //Syncfusion compilation changes..
                //return base.Y;
                return base.PinPoint.Y;
			}
			set
			{
                //Syncfusion compilation changes..
                //base.Y = value;
                base.PinPoint = new PointF(base.PinPoint.X, value);
			}
		}

		/// <summary>
		/// PropertyTable Associated With the symbol
		/// </summary>
		[Browsable(false)]
		public PropertyTable PT
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("PT");
                //if (value != null)
                //{
                //    return (PropertyTable)value;
                //}
				PT = new PropertyTable();
				return null;
			}
			set
			{
				try
				{
                    //Syncfusion compilation changes..
                    //this.SetPropertyValue("PT", value);
				}
				catch (Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}


		[Browsable(true)]
		public int Rows
		{
			get
			{
				return _rows;
			}
			set
			{
				if (ValidateRowColumns(value))
				{
					_oldRows = _rows;
					_rows = value;
					ChangeRows(value);
				}
			}
		}

		private int _oldCols;
		private int _oldRows;

		[Browsable(true)]
		public int Columns
		{
			get
			{
				return _cols;
			}
			set
			{
				if (ValidateRowColumns(value))
				{
					_oldCols = _cols;
					_cols = value;
                    //Syncfusion compilation changes..
                    //ChangeColumns(value);
				}
			}
		}


   //     private int _totalColumns;

        //public int TotalColumns
        //{
        //    get { return _totalColumns; }
        //    set { _totalColumns = value; }
        //}

//		private int _totalRows;

        //public int TotalRows
        //{
        //    get { return _totalRows; }
        //    set { _totalRows = value; }
        //}



		[Browsable(false)]
		public float ColumnWidth
		{
			get
			{
				return _colWidth;
			}
			set
			{
				_colWidth = ValidateDimension(value);
				ResizeAllColumnsWidth(_colWidth);
			}
		}


		[Browsable(false)]
		public float RowHeight
		{
			get
			{
				return _rowHeight;
			}
			set
			{
				_rowHeight = ValidateDimension(value);
				ResizeAllRowsHeight(_rowHeight);
			}
		}


		[Browsable(false)]
		public GridCell SelectedCell
		{
			get
			{
				return _selectedCell;
			}
			set
			{
				_selectedCell = value;
			}
		}



		[Browsable(false)]
		public new string Name
		{
			get
			{
				return base.Name;
			}
			set
			{
				base.Name = value;
			}
		}

		[Browsable(false), ReadOnly(false)]
		public string ID
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("ID");
                //if (value != null)
                //{
                //    return (string)value;
                //}
				return null;
			}
			set
			{
				try
				{
                    //Syncfusion compilation changes..
                    //this.SetPropertyValue("ID", value);
				}
				catch (Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}


		/// <summary>
		/// Link to Navigate to when symbol is double-clicked
		/// </summary>
		[Browsable(false), TypeConverter(typeof(LinkTypeConverter)), ReadOnly(false)]
		public Symcon.LightRidge.BusinessObjects.GraphicalLink Link
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("Link");
                //if (value != null)
                //{
                //    return (Symcon.LightRidge.BusinessObjects.GraphicalLink)value;
                //}
				return null;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.SetPropertyValue("Link", value);
                //this.Labels["Link"].Text = Link.Name;
                ((PathNode)((Node)this)).Labels["Link"].Text = Link.Name;
			}
		}


		[Browsable(true), Category("Header Information")]
		public new FillStyle FillStyle
		{
			get
			{
                //Syncfusion compilation changes..
                //return _headerCell.FillStyle;
                return ((FilledPath)((Node)this)).FillStyle;
			}
		}

        //Syncfusion compilation changes..
        //[Browsable(true), Category("Header Information")]
        //public BackgroundStyle BackGroundStyle
        //{
        //    get
        //    {
        //        return _headerCell.BackgroundStyle;
        //    }
        //}

        //[Browsable(true), ReadOnly(false), Category("Header Information")] //Syncfusion compilation changes..
		public Color BorderColor
		{
			get
			{
                //Syncfusion compilation changes..
                //return _headerCell.BorderStyle.BorderColor;
                return _headerCell.LineStyle.LineColor;
			}
			set
			{
                //Syncfusion compilation changes..
                //_headerCell.BorderStyle.BorderColor = value;
                _headerCell.LineStyle.LineColor = value;
			}
		}


		[Browsable(true), ReadOnly(false), Category("Header Information")]
		public bool ShowHeader
		{
			get
			{
				return _headerCell.Visible;
			}
			set
			{
				_headerCell.Visible = value;
			}
		}

		[Browsable(true), Category("Header Information")]
        public float BorderWidth//public int BorderWidth//Syncfusion compilation changes..
		{
			get
			{
                //Syncfusion compilation changes..
                //return _headerCell.BorderStyle.BorderWidth;
                return _headerCell.LineStyle.LineWidth;
			}
			set
			{
                //Syncfusion compilation changes..
                //_headerCell.BorderStyle.BorderWidth = value;
                _headerCell.LineStyle.LineWidth = value;
			}
		}

		[Browsable(true), Category("Header Information")]
		public string Text
		{
			get
			{
				return _headerCell.Text;
			}
			set
			{

				_headerCell.Text = value;
			}
		}


		[Browsable(true), Category("Header Information")]
		public float FontSize
		{
			get
			{
				return _headerCell.FontStyle.Size;
			}
			set
			{

				_headerCell.FontStyle.Size = value;
			}
		}


		[Browsable(true), Category("Header Information")]
		public System.Drawing.FontStyle TextStyle
		{
			get
			{
				return _headerCell.FontStyle.Style;
			}
			set
			{

				_headerCell.FontStyle.Style = value;
			}
		}


		[Browsable(true),  ReadOnly(false), TypeConverter(typeof(FontTypeConverter)),Category("Header Information")]		
		public string FontFamily
		{
			get
			{
				return _headerCell.FontStyle.Family;
			}
			set
			{

				_headerCell.FontStyle.Family = value;
			}
		}


		[Browsable(true), Category("Header Information")]
		public StringAlignment VerticalAlignment
		{
			get
			{
				return _headerCell.VerticalAlignment;
			}
			set
			{

				_headerCell.VerticalAlignment = value;
			}
		}


		[Browsable(true), Category("Header Information")]
		public StringAlignment HorizontalAlignment
		{
			get
			{
				return _headerCell.HorizontalAlignment;
			}
			set
			{

				_headerCell.HorizontalAlignment = value;
			}
		}

		[BrowsableAttribute(true), Category("Grid Information")]
		public bool ShowGridLines
		{
			get
			{

				return _showGridlines;
			}
			set
			{
                //Syncfusion compilation changes..
                //foreach (SymbolLabel lbl in this.Labels)
                //{
                //    lbl.BorderStyle.ShowBorder = value;

                //}
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
                {
                    //lbl.BorderStyle.ShowBorder = value;

                }
				_showGridlines = value;
				_oldIsVisible = value;
			}
		}


		[Browsable(true), Category("Grid Information")]
		public Color GridBorderColor
		{
			get
			{
				return _gridlineColor;
			}
			set
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
				{
					if (lbl.GetType() == typeof(GridHeaderCell))
						continue;
					else
					{
                        //Syncfusion compilation changes..
                        //lbl.BorderStyle.BorderColor = value;
					}
				}
				_gridlineColor = value;
			}

		}


		[Browsable(true), ReadOnly(false), Category("Grid Information")]
		public int GridBorderWidth
		{
			get
			{
				return _gridBorderWidth;
			}
			set
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
				{
					if (lbl.GetType() == typeof(GridHeaderCell))
						continue;
					else
					{
                        //Syncfusion compilation changes..
                        //lbl.BorderStyle.BorderWidth = value;
					}
				}
				_gridBorderWidth = value;
			}
		}


		private int _gridCellFont = 12;

		[Browsable(true), ReadOnly(false), Category("Grid Information")]
		public int CellsFontSize
		{
			get
			{
				return _gridCellFont;
			}
			set
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
				{
					if (lbl.GetType() == typeof(GridHeaderCell))
						continue;
					else
					{
						lbl.FontStyle.Size = value;
					}
				}
				_gridCellFont = value;
			}
		}


		private Color _cellsForeColor;
		[Browsable(true), ReadOnly(false), Category("Grid Information")]
		public Color CellsForeColor
		{
			get
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //if (_gridCellFontFamily == string.Empty && this.Labels[1] != null)
                if (_gridCellFontFamily == string.Empty && labels[1] != null)
				{
                    //Syncfusion compilation changes..
                    //_cellsForeColor = this.Labels[1].FillStyle.Color;
				}
				return _cellsForeColor;
			}
			set
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
				{
					if (lbl.GetType() == typeof(GridHeaderCell))
						continue;
					else
					{
                        //Syncfusion compilation changes..
                        //lbl.FillStyle.Color = value;
					}
				}
				_cellsForeColor = value;
			}
		}



		private Color _cellsBackColor;
		[Browsable(true), ReadOnly(false), Category("Grid Information")]
		public Color CellsBackColor
		{
			get
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //if (_gridCellFontFamily == string.Empty && this.Labels[1] != null)
                if (_gridCellFontFamily == string.Empty && labels[1] != null)
				{
                    //Syncfusion compilation changes..
                    //_cellsBackColor = this.Labels[1].BackgroundStyle.Color;
                    _cellsBackColor = labels[1].BackgroundStyle.Color;
				}
				return _cellsBackColor;
			}
			set
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
				{
					if (lbl.GetType() == typeof(GridHeaderCell))
						continue;
					else
					{
						lbl.BackgroundStyle.Color = value;
					}
				}
				_cellsBackColor = value;
			}
		}


		private string _gridCellFontFamily = "Arial";
		[Browsable(true),  ReadOnly(false), TypeConverter(typeof(FontTypeConverter)),Category("Grid Information")]	
		public string CellsFontFamily
		{
			get
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //if (_gridCellFontFamily == string.Empty && this.Labels[1] != null)
                if (_gridCellFontFamily == string.Empty && labels[1] != null)
				{
                    //Syncfusion compilation changes..
                    //_gridCellFontFamily = this.Labels[1].FontStyle.Family;
                    _gridCellFontFamily = labels[1].FontStyle.Family;
				}
				return _gridCellFontFamily;
			}
			set
			{
                //Syncfusion compilation changes..
                LabelCollection labels = ((PathNode)((Node)this)).Labels;
                //foreach (SymbolLabel lbl in this.Labels)
                foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in labels)
				{
					if (lbl.GetType() == typeof(GridHeaderCell))
						continue;
					else
					{
						lbl.FontStyle.Family = value;
					}
				}
				_gridCellFontFamily = value;
			}
		}


		internal GridHeaderCell HeaderCell
		{
			get
			{
				return _headerCell;
			}

		}

        //Syncfusion compilation change...
        //[Browsable(true), ReadOnly(false), Category("Grid Information")]
        //public bool AllowMove
        //{
        //    get
        //    {
        //        return base.EditStyle.AllowMove;
        //    }
        //    set
        //    {
        //        base.EditStyle.AllowMove = value;

        //    }
        //}
        [Browsable(true), ReadOnly(false), Category("Grid Information")]
        public bool AllowRotate
        {
            get
            {
                return base.EditStyle.AllowRotate;
            }
            set
            {
                base.EditStyle.AllowRotate = value;

            }
        }

		#endregion

		#region Public Methods

		//		public void ClearSelection()
		//		{
		//			if(this.SelectedCell != null)
		//			{
		//				this.SelectedCell.BorderStyle.BorderWidth = _oldBoderWidth;
		//				this.SelectedCell.BorderStyle.BorderColor = _oldColor;
		//				this.SelectedCell.BorderStyle.ShowBorder = _oldIsVisible;
		//			}
		//			this.SelectedCell = null;
		//
		//			if(this._model == null && this.Parent != null && this.Parent.GetType() == typeof(Syncfusion.Windows.Forms.Diagram.Model))
		//				_model = this.Parent as Syncfusion.Windows.Forms.Diagram.Model;
		//			if(_model != null)
		//				_model.UpdateViews();
		//		}
		#endregion

		#region Fields

		private int _rows = 2;
		private int _cols = 2;
		private float _colWidth = 50;
		private float _rowHeight = 20;
		private float _topLabelHeight = 20;
		private GridCell _selectedCell;
		//private ContextMenu ctxMenu;
		private Syncfusion.Windows.Forms.Diagram.Model _model = null;
		private int _oldBoderWidth;
		private bool _oldIsVisible;
		private Color _oldColor;
		private int _gridBorderWidth;
		private Color _gridlineColor = Color.DimGray;

		private Syncfusion.Windows.Forms.Diagram.Rectangle outerRect = null;
		private bool _showGridlines = true;
		private GridHeaderCell _headerCell;

		public event EventHandler GridCellRemoved;
		#endregion

		#region Events



		public void cellCtrl_GridCellClick(object sender, NodeMouseEventArgs evtArgs)
		{
			if (this.SelectedCell != null)
			{
				if (sender == this.SelectedCell)
					return;
                //Syncfusion compilation changes..
                //this.SelectedCell.BorderStyle.BorderWidth = _oldBoderWidth;
                //this.SelectedCell.BorderStyle.BorderColor = _oldColor;
                //this.SelectedCell.BorderStyle.ShowBorder = _oldIsVisible;
			}
			if (sender.GetType() == typeof(GridCell))
			{
				if (sender == this.SelectedCell)
					return;
				this.SelectedCell = sender as GridCell;
                //Syncfusion compilation changes..
                //_oldBoderWidth = this.SelectedCell.BorderStyle.BorderWidth;
                //_oldColor = this.SelectedCell.BorderStyle.BorderColor;
                //_oldIsVisible = this.SelectedCell.BorderStyle.ShowBorder;

				// _oldHighLightVisibility = this.HeaderCell.BorderStyle.ShowBorder;
                //Syncfusion compilation changes..
                //this.SelectedCell.BorderStyle.BorderWidth = this.SelectedCell.BorderStyle.BorderWidth + 2;
                //this.SelectedCell.BorderStyle.BorderColor = Color.DarkRed;
                //this.SelectedCell.BorderStyle.ShowBorder = true;

				// this._headerCell.BorderStyle.ShowBorder = true;
			}
			else
				this.SelectedCell = null;

			if (this._model == null && this.Parent != null && this.Parent.GetType() == typeof(Syncfusion.Windows.Forms.Diagram.Model))
				_model = this.Parent as Syncfusion.Windows.Forms.Diagram.Model;
            //Syncfusion compilation changes..
            //if (_model != null)
            //    _model.UpdateViews();

		}
		#endregion

	}
}
