using System;
using System.ComponentModel;
using System.Globalization;
using System.Runtime.Serialization;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using System.Reflection;
using System.Xml.Serialization;
using System.Drawing;

using Symcon.LightRidge.BusinessObjects.TypeConverters;

using Syncfusion.Windows.Forms.Diagram;

namespace Symcon.Lightridge.LRRUI.Controls
{
	[Serializable()]
	public class MiscSymbols : Node //Symbol //Syncfusion compilation change..
	{
		#region Constructor
		/// <summary>
		/// Default constructor.
		/// </summary>
		public MiscSymbols()
		{
			SetPropertyTable();
			this.ID=Guid.NewGuid().ToString();
			//CreateLabels();
			ArryIndexedProps = new ArrayList();

		
			for(int i = 0;i<4;i++)
			{
				ArryIndexedProps.Add("Null");
			}
			SymbolsUtils.CreateLabels(this);

		}



//			SymbolLabel lbl = new SymbolLabel(this);
//			lbl.Name = "Link";
//			//lbl.BorderStyle.ShowBorder = true;
//			lbl.FontStyle.Bold = true;
//			lbl.ReadOnly = true;
//			lbl.FillStyle.Color = System.Drawing.Color.White;
//			lbl.HorizontalAlignment = StringAlignment.Center;
//			lbl.VerticalAlignment = StringAlignment.Center;
//			lbl.FontStyle.Family = "Verdana";
//			lbl.FontStyle.Underline = true;
//			lbl.FontStyle.Size = 10f;
//			this.AddLabel(lbl);

		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
		public MiscSymbols(MiscSymbols src) : base(src)
		{
			try
			{
				MiscSymbols sourceMisc = src as MiscSymbols;
				MiscSymbols targetMisc = this;

				targetMisc.PT = null;
				targetMisc.MasterPlantItem = null;
				targetMisc.PlantItem = null;
                //Syncfusion compilation change..
                //targetMisc.FillStyle.AlphaFactor = sourceMisc.FillStyle.AlphaFactor;
                targetMisc.FillStyle.ColorAlphaFactor = sourceMisc.FillStyle.ColorAlphaFactor;
				targetMisc.FillStyle.Color = sourceMisc.FillStyle.Color;
				targetMisc.FillStyle.GradientAngle = sourceMisc.FillStyle.GradientAngle;
                //Syncfusion compilation change..
                //targetMisc.FillStyle.GradientBounds = sourceMisc.FillStyle.GradientBounds;
                //targetMisc.FillStyle.GradientStartColor = sourceMisc.FillStyle.GradientStartColor;
				targetMisc.FillStyle.Texture = sourceMisc.FillStyle.Texture;
				targetMisc.FillStyle.TextureWrapMode = sourceMisc.FillStyle.TextureWrapMode;
				targetMisc.FillStyle.Type = sourceMisc.FillStyle.Type;
                //Syncfusion compilation change..
                //targetMisc.EditStyle.AllowMove = sourceMisc.EditStyle.AllowMove;
                //targetMisc.EditStyle.AllowResize = sourceMisc.EditStyle.AllowResize;
				targetMisc.EditStyle.AllowRotate = sourceMisc.EditStyle.AllowRotate;
				targetMisc.EditStyle.AllowSelect = sourceMisc.EditStyle.AllowSelect;
				targetMisc.EditStyle.AllowVertexEdit = sourceMisc.EditStyle.AllowVertexEdit;
				targetMisc.EditStyle.DefaultHandleEditMode = sourceMisc.EditStyle.DefaultHandleEditMode;

				targetMisc.LineStyle.DashCap = sourceMisc.LineStyle.DashCap;
				targetMisc.LineStyle.DashOffset = sourceMisc.LineStyle.DashOffset;
				targetMisc.LineStyle.DashStyle = sourceMisc.LineStyle.DashStyle;
				targetMisc.LineStyle.EndCap = sourceMisc.LineStyle.EndCap;
				targetMisc.LineStyle.LineColor = sourceMisc.LineStyle.LineColor;
				targetMisc.LineStyle.LineJoin = sourceMisc.LineStyle.LineJoin;
				targetMisc.LineStyle.LineWidth = sourceMisc.LineStyle.LineWidth;
				targetMisc.LineStyle.MiterLimit = sourceMisc.LineStyle.MiterLimit;
                //Syncfusion compilation change..
                //targetMisc.Width = sourceMisc.Width;
                //targetMisc.Height = sourceMisc.Height;
                //targetMisc.Length = sourceMisc.Length;

				targetMisc.Visible = sourceMisc.Visible;
                //Syncfusion compilation change..
                //targetMisc.AutoHidePorts = sourceMisc.AutoHidePorts;

				targetMisc.ArryIndexedProps = null;
				targetMisc.ArryIndexedProps = sourceMisc.ArryIndexedProps.Clone() as ArrayList;
				for (int i = 0; i < 4; i++)
				{
					targetMisc.ArryIndexedProps[i] = "Null";
				}
				SetPropertyTable();
			}
			catch (Exception ex)
			{

			}
		}

		

		/// <summary>
		/// Serialization constructor for the MySymbol class.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected MiscSymbols(SerializationInfo info, StreamingContext context) : base(info, context)
		{
			// The Serialization constructor is invoked during deserialization or during a drag & drop operation.
			// If the MySymbol type has serializable members, then initialize them with the serialized data 
			// obtained from the SerializationInfo param
		}

		// Override SymbolBase.GetObjectData() and populate the SerializationInfo param 
		// with the data (if any) that belongs to the MySymbol type . This data will be 
		// serialized as a part of the Symbol object.

		#endregion

		#region Overrides
		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against</returns>
		public override object Clone()
		{
			return new MiscSymbols(this);
		}

//		protected override void OnBoundsChanged(BoundsEventArgs evtArgs)
//		{
//			
//			//Measurements.Convert(System.Drawing.GraphicsUnit.Pixel, System.Drawing.GraphicsUnit.World,evtArgs.Bounds);
//			//Measurements.Convert(System.Drawing.GraphicsUnit.Pixel, System.Drawing.GraphicsUnit.World,evtArgs.NewBounds);
//
//			//this.matrix = this.WorldTransform;
//			/*for(int j = this.Ports.Count ; j>0; j--)
//			{
//				this.Ports.Remove(this.Ports[j-1]);
//			}*/
//			
//			
//			MessageBox.Show((this.Ports[this.Ports.Count - 1].Location.X - this.Ports[this.Ports.Count - 2].Location.X).ToString());
//			for(int j = this.Ports.Count ; j>0; j--)
//			{
//				if(j- 2 >=0)
//				{
//					if((this.Ports[j- 1].Location.X - this.Ports[j - 2].Location.X) > 20)
//					{
//					
//						CirclePort cPort = new CirclePort(this);
//						cPort.AttachAtPerimeter = true;
//						PointF pt = new PointF((this.Ports[j-1].Location.X - this.Ports[j-2].Location.X)/2,this.Location.Y);
//
//						PointF[] ptarry = new PointF[1]
//							{
//								pt
//							};
//						this.WorldTransform.TransformPoints(ptarry);
//
//						/*cPort.Location = ptr[0];*/
//						cPort.Location = ptarry[0];
//						this.Ports.Add(cPort);
//					}
//				}
//																				   
//			}
////			float startX = 0.0f;
////			for(int i = 0;i<evtArgs.NewBounds.Size.Width/2 ; i = i+20)
////			{
////				//evtArgs.NewBounds - evtArgs.OldBounds;
////				SizeF sz = new SizeF((float)BoxPosition.MiddleLeft + i, this.Location.Y);
////                
////								
////				//PointF pt = new PointF();
////				//pt.X	= evtArgs.NewBounds.Size.ToPointF().X +i;
////				//pt.Y	= evtArgs.NewBounds.Size.ToPointF().Y;
////			
////				
////					
////				
////
////				this.WorldTransform.Translate((float)i,0);// = (float)i;
////				PointF pt = new PointF(sz.ToPointF().X, sz.ToPointF().Y);
////				
////				PointF[] ptr = new PointF[1]
////					{
////						pt
////					};
////				this.WorldTransform.TransformPoints(ptr);
////				
////				CirclePort cPort = new CirclePort(this);
////				cPort.AttachAtPerimeter = true;
////				/*cPort.Location = ptr[0];*/
////				cPort.Location = new PointF(startX,this.Location.Y);
////				//this.Ports.Add(cPort);
////				startX+=20.0f;
////				//MessageBox.Show(this.GraphicsPath.PointCount.ToString());
////			}
//		
//			base.OnBoundsChanged (evtArgs);
//		}
//


//		protected override void OnScale(ScaleEventArgs evtArgs)
//		{
//e
//
//			CirclePort cPort = new CirclePort(this);
//
//			for(int i = 0;i<this.Width ; i = i+20)
//			{
//				PointF pt = new PointF(this.X + i, this.Y + this.Height / 2);
//				
//				this.Ports.Add(cPort);
//
//			}
//
//			base.OnScale (evtArgs);
//		}

		#endregion

		#region	Public Properties 
		
		/// <summary>
		/// Link to Navigate to when symbol is double-clicked
		/// </summary>
		[Browsable(true),TypeConverter(typeof(LinkTypeConverter)),ReadOnly(false)]
		public Symcon.LightRidge.BusinessObjects.GraphicalLink Link
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("Link");
                //if (value != null && value.GetType() != typeof(string))
                //{
                //    return (Symcon.LightRidge.BusinessObjects.GraphicalLink) value;
                //}
				return null;
			}
			set
			{
                //Syncfusion compilation change..
                //this.SetPropertyValue("Link", value);
                //this.Labels["Link"].Text = Link.Name;
                ((PathNode)((Node)this)).Labels["Link"].Text = Link.Name;
			}
		}


		[Browsable(true),ReadOnly(false)]
		public new LineStyle LineStyle
		{
			get
			{
				return base.LineStyle;
			}
		}

		[Browsable(true),ReadOnly(false)]
		public new FillStyle FillStyle
		{
			get
			{
                //Syncfusion compilation change..
                //return base.FillStyle;
                return ((FilledPath)((Node)this)).FillStyle;
			}
		}

		[Browsable(true),ReadOnly(false)]
		public bool LockAspectRatio
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("LockAspectRatio");
                //if (value != null)
                //{
                //    return (bool) value;
                //}
				return true;
			}
			set
			{
                //Syncfusion compilation change..
                //this.SetPropertyValue("LockAspectRatio", value);
			}
		}


		/// <summary>
		/// Link Id
		/// </summary>
		[Browsable(false),ReadOnly(false)]
		public string LinkID
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("LinkID");
                //if (value != null)
                //{
                //    return (string) value;
                //}
				return null;
			}
			set
			{
                //Syncfusion compilation change..
                //this.SetPropertyValue("LinkID", value);
			}
		}

		/// <summary>
		/// The Width of Symbol
		/// </summary>
        /// 
        //Syncfusion compilation change..
        //[Browsable(true)]
        //public float Length
        //{
        //    get
        //    {
        //        return (float) base.Width;
        //    }
        //    set
        //    {
        //        if (value == 0)
        //        {
        //            value = .01f;
        //        }
        //        base.Width = value;
        //    }
        //}

        ///// <summary>
        ///// The Width of Symbol
        ///// </summary>
        //[Browsable(true)]
        //public new float Height
        //{
        //    get
        //    {
        //        return (float) base.Height;
        //    }
        //    set
        //    {
        //        if (value == 0)
        //        {
        //            value = .01f;
        //        }
        //        base.Height = value;
        //    }
        //}



        ///// <summary>
        ///// The X Cordinate of Symbol w.r.t the Canvas
        ///// </summary>
        //[Browsable(true)]
        //public new float X
        //{
        //    get
        //    {
        //        return base.X;
        //    }
        //    set
        //    {
        //        base.X = value;
        //    }
        //}


        ///// <summary>
        ///// The Y Cordinate of Symbol w.r.t the Canvas
        ///// </summary>
        //[Browsable(true)]
        //public new float Y
        //{
        //    get
        //    {
        //        return base.Y;
        //    }
        //    set
        //    {
        //        base.Y = value;
        //    }
        //}



		/// <summary>
		/// Set of Labels 
		/// </summary>
		[Browsable(false)]
		public LabelCollection BoundProperties
		{
			get
			{
                //Syncfusion compilation change..
                //return base.Labels;
                return ((PathNode)((Node)this)).Labels;
			}
		}



		/// <summary>
		/// The Type of Master Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(true),TypeConverter(typeof(SymbolTypeConverter)), 
		CategoryAttribute("Binding Information")]
		public Symcon.LightRidge.BusinessObjects.MasterPlantItem MasterPlantItem
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("MasterPlantItem");
                //if (value != null)
                //{
                //    return (Symcon.LightRidge.BusinessObjects.MasterPlantItem) value;
                //}
				return null;
			}
			set
			{
                //Syncfusion compilation change..
                //this.SetPropertyValue("MasterPlantItem", value);
                //this.SetPropertyValue("PlantItem", null);
			}
		}


		/// <summary>
		/// The Type of Master Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(false),TypeConverter(typeof(SymbolTypeConverter)), 
		CategoryAttribute("Binding Information")]
		public string ItemType
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("ItemType");
                //if (value != null)
                //{
                //    return (string) value;
                //}
				return null;
			}
			set
			{
                //Syncfusion compilation change..
                //this.SetPropertyValue("ItemType", value);
                //this.SetPropertyValue("SiteItem", null);
			}
		}


		/// <summary>
		/// The Type of Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(true),TypeConverter(typeof(ObjectNameConverter)), 
		CategoryAttribute("Binding Information")]
		public Symcon.LightRidge.BusinessObjects.SiteItem PlantItem
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("PlantItem");
                //if (value != null)
                //{
                //    return (Symcon.LightRidge.BusinessObjects.SiteItem) value;
                //}
				return null;
			}
			set
			{
                //Syncfusion compilation change..
                //this.SetPropertyValue("PlantItem", value);
			}
		}



		/// <summary>
		/// The Type of Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(false),TypeConverter(typeof(ObjectNameConverter)), 
		CategoryAttribute("Binding Information")]
		public string SiteItem
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("SiteItem");
                //if (value != null)
                //{
                //    return (string) value;
                //}
				return null;
			}
			set
			{
                //Syncfusion compilation change..
                //this.SetPropertyValue("SiteItem", value);
			}
		}

		
		/// <summary>
		/// PropertyTable Associated With the symbol
		/// </summary>
		[Browsable(false)]
		public PropertyTable PT
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("PT");
                //if (value != null)
                //{
                //    return (PropertyTable) value;
                //}
				PT = new PropertyTable();
				return null;
			}
			set
			{
				try
				{
                    //Syncfusion compilation change..
                    //this.SetPropertyValue("PT", value);
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false), ReadOnly(false)]
		public string SymbolName 
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("SymbolName");
                //if (value != null)
                //{
                //    return (string) value;
                //}
				return "Test";
			}
			set
			{
				try
				{
                    //Syncfusion compilation change..
                    //this.SetPropertyValue("SymbolName", value);
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false), ReadOnly(false)]
		public string ID
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("ID");
                //if (value != null)
                //{
                //    return (string) value;
                //}
				return null;
			}
			set
			{
				try
				{
                    //Syncfusion compilation change..
                    //this.SetPropertyValue("ID", value);
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false),ReadOnly(false)]
		public ArrayList ArryIndexedProps
		{
			get
			{
                //Syncfusion compilation change..
                //object value = this.GetPropertyValue("ArryIndexedProps");
                //if (value != null)
                //{
                //    return (ArrayList) value;
                //}
				return null;
			}
			set
			{
                //Syncfusion compilation change..
                //this.SetPropertyValue("ArryIndexedProps", value);
			}
				
		}

		#endregion

		#region Overrides





		#endregion

		#region Methods
		
		private void SetPropertyTable()
		{
			if(PT == null)
			{
				try
				{
					PropertyInfo[] properties =	this.GetType().GetProperties(BindingFlags.Instance | BindingFlags.DeclaredOnly | BindingFlags.Public);
				
					foreach	(PropertyInfo property in properties)
					{
						BrowsableAttribute[] attr = property.GetCustomAttributes(typeof(BrowsableAttribute),false) as BrowsableAttribute[];
						if(attr.Length > 0)
							if(((BrowsableAttribute)attr[0]).Browsable == false)
								continue;
						string propname	= property.Name;
						if(property.Name == "MasterPlantItem")
						{
							//PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Select the Type of Symbol" ,this.GetPropertyValue(property.Name),"",typeof(SymbolTypeConverter),this));
                            //Syncfusion compilation change..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists of Master Plant Item" ,this.GetPropertyValue(property.Name),"",typeof(SymbolTypeConverter),this));
						}
						else if(property.Name == "PlantItem" )
						{
							//PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists the Bound objects of selected type" ,this.GetPropertyValue(property.Name),"",typeof(ObjectNameConverter),this));
                            //Syncfusion compilation change..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists the Plant Item objects of Selected Master Plant Item",this.GetPropertyValue(property.Name),"",typeof(ObjectNameConverter),this));
							//siteitemps = new PropertySpec("PlantItem",typeof(SiteItem),"Binding Information","Lists the Plant Item objects of Selected Master Plant Item" ,si,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.ObjectNameConverter),sm);
						}
						else if(property.Name == "Link")
						{
                            //Syncfusion compilation change..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Link","Select the Link for the Symbol" ,this.GetPropertyValue(property.Name),"",typeof(LinkTypeConverter),this));
						}
						else
						{
                            //Syncfusion compilation change..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"General	Properties","Sets the " + property.Name + " property of selected symbol",this.GetPropertyValue(property.Name),"","", this));
						}
					}

				}	
				catch(Exception	ex)
				{
					Debug.Assert(false,ex.Message);
				}
			}
		}

		#endregion
	}
}