using System;
using System.ComponentModel;
using System.Globalization;
using System.Runtime.Serialization;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using System.Reflection;
using System.Xml.Serialization;
using System.Drawing;

using Symcon.LightRidge.BusinessObjects.TypeConverters;

using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using System.Drawing.Drawing2D;
namespace Symcon.Lightridge.LRRUI.Controls
{
	[Serializable()]
    public class SourceSink : Node //Symbol  //Syncfusion compilation changes..
	{
		#region Constructor
		/// <summary>
		/// Default constructor.
		/// </summary>
		public SourceSink()
		{
			SetPropertyTable();
			this.ID=Guid.NewGuid().ToString();
			ArryIndexedProps = new ArrayList();

		
			for(int i = 0;i<4;i++)
			{
				ArryIndexedProps.Add("Null");
			}

			SymbolsUtils.CreateLabels(this);
		}


		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
		public SourceSink(SourceSink src) : base(src)
		{
			try
			{
				SourceSink sourceSSink = src as SourceSink;
				SourceSink targetSSink = this;

				targetSSink.PT = null;
				targetSSink.MasterPlantItem = null;
				targetSSink.PlantItem = null;
                //Syncfusion compilation changes..
                //targetSSink.FillStyle.AlphaFactor = sourceSSink.FillStyle.AlphaFactor;
                targetSSink.FillStyle.ColorAlphaFactor = sourceSSink.FillStyle.ColorAlphaFactor;
				targetSSink.FillStyle.Color = sourceSSink.FillStyle.Color;
				targetSSink.FillStyle.GradientAngle = sourceSSink.FillStyle.GradientAngle;
                //Syncfusion compilation changes..
                //targetSSink.FillStyle.GradientBounds = sourceSSink.FillStyle.GradientBounds;
                //targetSSink.FillStyle.GradientStartColor = sourceSSink.FillStyle.GradientStartColor;
				targetSSink.FillStyle.Texture = sourceSSink.FillStyle.Texture;
				targetSSink.FillStyle.TextureWrapMode = sourceSSink.FillStyle.TextureWrapMode;
				targetSSink.FillStyle.Type = sourceSSink.FillStyle.Type;
                
                //Syncfusion compilation changes..
                //targetSSink.EditStyle.AllowMove = sourceSSink.EditStyle.AllowMove;
                //targetSSink.EditStyle.AllowResize = sourceSSink.EditStyle.AllowResize;
				targetSSink.EditStyle.AllowRotate = sourceSSink.EditStyle.AllowRotate;
				targetSSink.EditStyle.AllowSelect = sourceSSink.EditStyle.AllowSelect;
				targetSSink.EditStyle.AllowVertexEdit = sourceSSink.EditStyle.AllowVertexEdit;
				targetSSink.EditStyle.DefaultHandleEditMode = sourceSSink.EditStyle.DefaultHandleEditMode;

				targetSSink.LineStyle.DashCap = sourceSSink.LineStyle.DashCap;
				targetSSink.LineStyle.DashOffset = sourceSSink.LineStyle.DashOffset;
				targetSSink.LineStyle.DashStyle = sourceSSink.LineStyle.DashStyle;
				targetSSink.LineStyle.EndCap = sourceSSink.LineStyle.EndCap;
				targetSSink.LineStyle.LineColor = sourceSSink.LineStyle.LineColor;
				targetSSink.LineStyle.LineJoin = sourceSSink.LineStyle.LineJoin;
				targetSSink.LineStyle.LineWidth = sourceSSink.LineStyle.LineWidth;
				targetSSink.LineStyle.MiterLimit = sourceSSink.LineStyle.MiterLimit;
                //Syncfusion compilation changes..
                //targetSSink.Width = sourceSSink.Width;
                //targetSSink.Height = sourceSSink.Height;
                //targetSSink.Length = sourceSSink.Length;

				targetSSink.Visible = sourceSSink.Visible;
                //Syncfusion compilation changes..
                //targetSSink.AutoHidePorts = sourceSSink.AutoHidePorts;
				targetSSink.BorderWidth = sourceSSink.BorderWidth;

				targetSSink.Transparency = sourceSSink.Transparency;

				targetSSink.ArryIndexedProps = null;
				targetSSink.ArryIndexedProps = sourceSSink.ArryIndexedProps.Clone() as ArrayList;
				for (int i = 0; i < 4; i++)
				{
					targetSSink.ArryIndexedProps[i] = "Null";
				}

				SetPropertyTable();
			}
			catch (Exception ex)
			{

			}
		}



		/// <summary>
		/// Serialization constructor for the MySymbol class.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected SourceSink(SerializationInfo info, StreamingContext context) : base(info, context)
		{
			// The Serialization constructor is invoked during deserialization or during a drag & drop operation.
			// If the MySymbol type has serializable members, then initialize them with the serialized data 
			// obtained from the SerializationInfo param
		}

		// Override SymbolBase.GetObjectData() and populate the SerializationInfo param 
		// with the data (if any) that belongs to the MySymbol type . This data will be 
		// serialized as a part of the Symbol object.

		#endregion

		#region Overrides
		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against</returns>
		public override object Clone()
		{
			return new SourceSink(this);
		}

//		protected override void OnBoundsChanged(BoundsEventArgs evtArgs)
//		{
//			base.OnBoundsChanged (evtArgs);
//			for(int j = this.Ports.Count ; j>0; j--)
//			{
//				this.Ports.Remove(this.Ports[j-1]);
//			}                                         
//			float xoffset = this.X;
//			while(xoffset < (this.X + this.Width))
//			{
//				PointF ptworld = new PointF(xoffset, this.Location.Y + this.Height / 2);
//				PointF[] pts = new PointF[] {ptworld};
//				Matrix worldxform = this.WorldTransform;
//				worldxform.Invert();
//				worldxform.TransformPoints(pts);
//				CirclePort cPort = new CirclePort(pts[0]);
//				this.Ports.Add(cPort);
//				xoffset += 10f;                                             
//			} 
//		}

		#endregion

		#region	Public Properties 
		
		/// <summary>
		/// Link to Navigate to when symbol is double-clicked
		/// </summary>
        
        //Syncfusion compilation changes..
        [Browsable(true), ReadOnly(false)]
        public new FillStyle FillStyle
        {
            get
            {
                return ((FilledPath)((Node)this)).FillStyle;
            }
        }

		[Browsable(true),TypeConverter(typeof(LinkTypeConverter)),ReadOnly(false)]
		public Symcon.LightRidge.BusinessObjects.GraphicalLink Link
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("Link");
                object value = this.GetPropertyContainerByName("Link");
				if (value != null && value.GetType() != typeof(string))
				{
					return (Symcon.LightRidge.BusinessObjects.GraphicalLink) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.SetPropertyValue("Link", value);
                //this.Labels["Link"].Text = Link.Name;
                this.SetPropertyTable();
                ((PathNode)((Node)this)).Labels["Link"].Text = Link.Name;
			}
		}

		
		[Browsable(true),ReadOnly(false)]
		public float BorderWidth
		{
			get
			{
				return this.LineStyle.LineWidth;
			}
			set
			{
				this.LineStyle.LineWidth = value;
			}
		}

		[Browsable(true),ReadOnly(false),DefaultValue(true)]
		public bool LockAspectRatio
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("LockAspectRatio");
                object value = this.GetPropertyContainerByName("LockAspectRatio");
				if (value != null)
				{
					return (bool) value;
				}
				return true;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.SetPropertyValue("LockAspectRatio", value);
                this.SetPropertyTable();
			}
		}



		
		[Browsable(true),ReadOnly(false)]
		public int Transparency
		{
			get
			{
                //Syncfusion compilation changes..
                //return this.FillStyle.AlphaFactor;
                return this.FillStyle.ColorAlphaFactor;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.FillStyle.AlphaFactor = value;
                this.FillStyle.ColorAlphaFactor = value;
			}
		}


		/// <summary>
		/// Link Id
		/// </summary>
		[Browsable(false),ReadOnly(false)]
		public string LinkID
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("LinkID");
                object value = this.GetPropertyContainerByName("LinkID");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.SetPropertyValue("LinkID", value);
			}
		}

		/// <summary>
		/// The Width of Symbol
		/// </summary>
		[Browsable(true)]
		public float Length
		{
			get
			{
                //Syncfusion compilation changes..
                //return (float) base.Width;
                return (float)base.Size.Width;
			}
			set
            {
                if (value == 0)
                {
                    value = .01f;
                }
                //Syncfusion compilation changes..
                //base.Width = value;
                base.Size = new SizeF(value, base.Size.Height);
			}
		}

		/// <summary>
		/// The Width of Symbol
		/// </summary>
		[Browsable(true)]
		public new float Height
		{
			get
			{
                //Syncfusion compilation changes..
                //return (float) base.Height;
                return (float)base.Size.Height;
			}
			set
            {
                if (value == 0)
                {
                    value = .01f;
                }
                //Syncfusion compilation changes..
                //base.Height = value;
                base.Size = new SizeF(base.Size.Width, value);
			}
		}



		/// <summary>
		/// The X Cordinate of Symbol w.r.t the Canvas
		/// </summary>
		[Browsable(true)]
		public new float X
		{
			get
			{
                //Syncfusion compilation changes..
                //return base.X;
                return base.PinPoint.X;
			}
			set
			{
                //Syncfusion compilation changes..
                //base.X = value;
                base.PinPoint = new PointF(value, base.PinPoint.Y);
			}
		}


		/// <summary>
		/// The Y Cordinate of Symbol w.r.t the Canvas
		/// </summary>
		[Browsable(true)]
		public new float Y
		{
			get
			{
                //Syncfusion compilation changes..
                //return base.Y;
                return base.PinPoint.Y;
			}
			set
			{
                //Syncfusion compilation changes..
                //base.Y = value;
                base.PinPoint = new PointF(base.PinPoint.X, value);
			}
		}



		/// <summary>
		/// Set of Labels 
		/// </summary>
		[Browsable(false)]
		public LabelCollection BoundProperties
		{
			get
			{
                //Syncfusion compilation changes..
                //return base.Labels;
                return ((PathNode)((Node)this)).Labels;
			}
		}



		/// <summary>
		/// The Type of Master Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(true),TypeConverter(typeof(SymbolTypeConverter)), 
		CategoryAttribute("Binding Information")]
		public Symcon.LightRidge.BusinessObjects.MasterPlantItem MasterPlantItem
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("MasterPlantItem");
                object value = this.GetPropertyContainerByName("MasterPlantItem");
				if (value != null)
				{
					return (Symcon.LightRidge.BusinessObjects.MasterPlantItem) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.SetPropertyValue("MasterPlantItem", value);
                //this.SetPropertyValue("PlantItem", null);
			}
		}


		/// <summary>
		/// The Type of Master Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(false),TypeConverter(typeof(SymbolTypeConverter)), 
		CategoryAttribute("Binding Information")]
		public string ItemType
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("ItemType");
                object value = this.GetPropertyContainerByName("ItemType");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.SetPropertyValue("ItemType", value);
                //this.SetPropertyValue("SiteItem", null);
			}
		}


		/// <summary>
		/// The Type of Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(true),TypeConverter(typeof(ObjectNameConverter)), 
		CategoryAttribute("Binding Information")]
		public Symcon.LightRidge.BusinessObjects.SiteItem PlantItem
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("PlantItem");
                object value = this.GetPropertyContainerByName("PlantItem");
				if (value != null)
				{
					return (Symcon.LightRidge.BusinessObjects.SiteItem) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.SetPropertyValue("PlantItem", value);
			}
		}



		/// <summary>
		/// The Type of Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(false),TypeConverter(typeof(ObjectNameConverter)), 
		CategoryAttribute("Binding Information")]
		public string SiteItem
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("SiteItem");
                object value = this.GetPropertyContainerByName("SiteItem");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.SetPropertyValue("SiteItem", value);
			}
		}

		
		/// <summary>
		/// PropertyTable Associated With the symbol
		/// </summary>
		[Browsable(false)]
		public PropertyTable PT
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("PT");
                object value = this.GetPropertyContainerByName("PT");
				if (value != null)
				{
					return (PropertyTable) value;
				}
				PT = new PropertyTable();
				return null;
			}
			set
			{
				try
				{
                    //Syncfusion compilation changes..
                    //this.SetPropertyValue("PT", value);
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false), ReadOnly(false)]
		public string SymbolName 
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("SymbolName");
                object value = this.GetPropertyContainerByName("SymbolName");
				if (value != null)
				{
					return (string) value;
				}
				return "Test";
			}
			set
			{
				try
				{
                    //Syncfusion compilation changes..
                    //this.SetPropertyValue("SymbolName", value);
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false), ReadOnly(false)]
		public string ID
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("ID");
                object value = this.GetPropertyContainerByName("ID");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
				try
				{
                    //Syncfusion compilation changes..
                    //this.SetPropertyValue("ID", value);
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false),ReadOnly(false)]
		public ArrayList ArryIndexedProps
		{
			get
			{
                //Syncfusion compilation changes..
                //object value = this.GetPropertyValue("ArryIndexedProps");
                object value = this.GetPropertyContainerByName("ArryIndexedProps");
				if (value != null)
				{
					return (ArrayList) value;
				}
				return null;
			}
			set
			{
                //Syncfusion compilation changes..
                //this.SetPropertyValue("ArryIndexedProps", value);
			}
				
		}

		#endregion

		#region Overrides


		#endregion

		#region Methods

		private void SetPropertyTable()
		{
			if(PT == null)
			{
				try
				{
					PropertyInfo[] properties =	this.GetType().GetProperties(BindingFlags.Instance | BindingFlags.DeclaredOnly | BindingFlags.Public);
				
					foreach	(PropertyInfo property in properties)
					{
						BrowsableAttribute[] attr = property.GetCustomAttributes(typeof(BrowsableAttribute),false) as BrowsableAttribute[];
						if(attr.Length > 0)
							if(((BrowsableAttribute)attr[0]).Browsable == false)
								continue;
						string propname	= property.Name;
						if(property.Name == "MasterPlantItem")
						{
							//PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Select the Type of Symbol" ,this.GetPropertyValue(property.Name),"",typeof(SymbolTypeConverter),this));
                            //Syncfusion compilation changes..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists of Master Plant Item" ,this.GetPropertyValue(property.Name),"",typeof(SymbolTypeConverter),this));
                            PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "Binding Information", "Lists of Master Plant Item", this.GetPropertyContainerByName(property.Name), "", typeof(SymbolTypeConverter), this));
						}
						else if(property.Name == "PlantItem" )
						{
							//PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists the Bound objects of selected type" ,this.GetPropertyValue(property.Name),"",typeof(ObjectNameConverter),this));
                            //Syncfusion compilation changes..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists the Plant Item objects of Selected Master Plant Item",this.GetPropertyValue(property.Name),"",typeof(ObjectNameConverter),this));
                            PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "Binding Information", "Lists the Plant Item objects of Selected Master Plant Item", this.GetPropertyContainerByName(property.Name), "", typeof(ObjectNameConverter), this));
							//siteitemps = new PropertySpec("PlantItem",typeof(SiteItem),"Binding Information","Lists the Plant Item objects of Selected Master Plant Item" ,si,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.ObjectNameConverter),sm);
						}
						else if(property.Name == "Link")
						{
                            //Syncfusion compilation changes..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Link","Select the Link for the Symbol" ,this.GetPropertyValue(property.Name),"",typeof(LinkTypeConverter),this));
                            PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "Link", "Select the Link for the Symbol", this.GetPropertyContainerByName(property.Name), "", typeof(LinkTypeConverter), this));
						}
						else
						{
                            //Syncfusion compilation changes..
                            //PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"General	Properties","Sets the " + property.Name + " property of selected symbol",this.GetPropertyValue(property.Name),"","", this));
                            PT.Properties.Add(new PropertySpec(property.Name, property.PropertyType, "General	Properties", "Sets the " + property.Name + " property of selected symbol", this.GetPropertyContainerByName(property.Name), "", "", this));
						}
					}
				}	
				catch(Exception	ex)
				{
					Debug.Assert(false,ex.Message);
				}
			}
		}

		#endregion

		#region Fields
		private string					id;
		#endregion
	}
}
