using System;
using Syncfusion.Windows.Forms.Diagram;
using System.Drawing;
using System.Runtime.Serialization;
using System.Drawing.Drawing2D;
using System.ComponentModel;


namespace Symcon.Lightridge.LRRUI.Controls.Tools
{
	[Serializable]
	public class OrthogonalLink : OrthogonalConnector//Link //Syncfusion compilation change..
	{
		#region
        //Syncfusion compilation change..

        //private EndPointDecorator _endPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
        //private EndPointDecorator _startPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
		private OrthogonalLine _line;
		#endregion

        //Syncfusion compilation change..

        //public OrthogonalLink()
        //{
        //}

        //public OrthogonalLink(PointF[] pts):base(pts)
        //{
        //}
        public OrthogonalLink(PointF ptStart, PointF ptEnd)
            : base(ptStart, ptEnd)
        {
        }

        public OrthogonalLink(PointF[] pts)
            : base(pts[0], pts[pts.Length - 1])
        {
        }

		
		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
		public OrthogonalLink(OrthogonalLink src) : base(src)
		{

		}

		/// <summary>
		/// Serialization constructor for symbols.
		/// </summary>
		/// <param name="info">Serialization state information.</param>
		/// <param name="context">Streaming context information.</param>
		protected OrthogonalLink(SerializationInfo info, StreamingContext context) : base(info, context)
		{
		}


		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against</returns>
		public override object Clone()
		{
			return new OrthogonalLink(this);
		}

        //Syncfusion compilation change..
        //protected override IPoints CreateLinkShape(Syncfusion.Windows.Forms.Diagram.Link.Shapes shapeType, PointF[] pts)
        //{
        //    Shape linkShape	= null;
        //    try
        //    {
				
        //        _line =	new	OrthogonalLine();
				
        //        linkShape =	_line;
        //        if(linkShape !=	null)
        //        {
        //            linkShape.SetPoints(pts);
        //        }

        //    }
        //    catch(Exception ex)
        //    {
        //        string msg = ex.Message;
        //    }
        //    return linkShape;
        //}
        /* CreateLinkShape method is no longer available. We suggest you to use the 
         * CreateLogicalGraphicsPath instead of that method*/
        protected override GraphicsPath CreateLogicalGraphicsPath(PointF[] pts)
        {
            return base.CreateLogicalGraphicsPath(pts);
        }

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		#region Properties
        //Syncfusion compilation chnage..
        /* Decorators are read only properties. We cannot assign value to it. We suggest you to use the decoratorShape property of decorator
         * in order to assign different decorator shapes*/

        //[Category("LineCap"),Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public EndPointDecorator EndCap
        //{
        //    get
        //    {
        //        return this.EndPoints.LastEndPointDecorator;
        //    }
        //    set
        //    {
        //        this.EndPoints.LastEndPointDecorator = value;
        //        if(this.EndPoints.LastEndPointDecorator != null)
        //        {
        //            //this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.EndPoints.LastEndPointDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}


        //[Category("LineCap"), Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public EndPointDecorator StartCap
        //{
        //    get
        //    {
        //        return this.EndPoints.FirstEndPointDecorator;
        //    }
        //    set
        //    {
        //        this._line.FirstEndPointDecorator = value;
        //        if(this.EndPoints.FirstEndPointDecorator != null)
        //        {
        //            //this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.EndPoints.FirstEndPointDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}


		[Category("LineCap"),TypeConverter(typeof(SizeConverter))]
		public Size EndCapSize
		{
			get
			{
                //Syncfusion compilation chnage..
                //if(this.EndPoints.LastEndPointDecorator != null)
                //    return this.EndPoints.LastEndPointDecorator.Size.ToSize();
                if (this.HeadDecorator != null)
                    return this.HeadDecorator.Size.ToSize();
				else 
					return new Size(0,0);

			}
			set
			{
                //Syncfusion compilation change..
                //this.EndPoints.LastEndPointDecorator.Size = value;
                this.HeadDecorator.Size = value;
			}
		}


		[Category("LineCap"),DefaultValue(typeof(Size),null),TypeConverter(typeof(SizeConverter))]
		public Size StartCapSize
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.FirstEndPointDecorator != null)
                //    return this.EndPoints.FirstEndPointDecorator.Size.ToSize();
                if (this.TailDecorator != null)
                    return this.TailDecorator.Size.ToSize();
				else 
					return new Size(0,0);
			}
			set
			{
                //Syncfusion compilation change..
                //this.EndPoints.FirstEndPointDecorator.Size = value;
                this.TailDecorator.Size = value;
			}
		}

		[Category("LineCap")]
		public FillStyle StartCapFillStyle
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.FirstEndPointDecorator != null)
                //    return this.EndPoints.FirstEndPointDecorator.FillStyle;
                if (this.TailDecorator != null)
                    return this.TailDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public FillStyle EndCapFillStyle
		{
			get
			{
                //Syncfusion compilation change.
                //if(this.EndPoints.LastEndPointDecorator != null)
                //    return this.EndPoints.LastEndPointDecorator.FillStyle;
                if (this.HeadDecorator != null)
                    return this.HeadDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public LineStyle EndCapLineStyle
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.LastEndPointDecorator != null)
                //    return this.EndPoints.LastEndPointDecorator.LineStyle;
                if (this.HeadDecorator != null)
                    return this.HeadDecorator.LineStyle;
				else 
					return null;
			}
		}


	
		[Category("LineCap")]
		public LineStyle StartCapLineStyle
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.FirstEndPointDecorator != null)
                //    return this.EndPoints.FirstEndPointDecorator.LineStyle;
                if (this.TailDecorator != null)
                    return this.TailDecorator.LineStyle;
				else 
					return null;
			}
		}

		#endregion

		#region Overrides
		//Syncfusion compilation change..
        //protected override void OnPropertyChanged(PropertyEventArgs evtArgs)
        //{
        //    base.OnPropertyChanged (evtArgs);
        //    if(evtArgs.PropertyName == "LineColor")
        //    {
        //        if(this.EndPoints.LastEndPointDecorator != null)
        //        {
        //            this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = (Color)evtArgs.NewValue;
        //            this.EndPoints.LastEndPointDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //        if(this.EndPoints.FirstEndPointDecorator != null)
        //        {
        //            this.EndPoints.FirstEndPointDecorator.LineStyle.LineColor = (Color) evtArgs.NewValue;
        //            this.EndPoints.FirstEndPointDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //    }
			
        //}
        public override void OnPropertyChanged(string strPropertyContainerName, string strPropertyName)
        {
            base.OnPropertyChanged(strPropertyContainerName, strPropertyName);
            if (strPropertyName == "LineColor")
            {
                if (this.HeadDecorator != null)
                {
                    this.HeadDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.HeadDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
                if (this.TailDecorator != null)
                {
                    this.TailDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.TailDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
            }
        }

		#endregion 

	}
}
