using System;
using Syncfusion.Windows.Forms.Diagram;
using System.Drawing;
using System.Runtime.Serialization;
using System.Drawing.Drawing2D;
using System.ComponentModel;


namespace Symcon.Lightridge.LRRUI.Controls.Tools
{
	[Serializable]
	public class SimpleLink : LineConnector//Link //Syncfusion compilation change..
	{
		#region Fields
		//private EndPointDecorator _endPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
		//private EndPointDecorator _startPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
//		private PolyLine _line;
		#endregion

		#region Constructors

        //Syncfusion compilation change..
        //public SimpleLink():base()
        //{

        //}
        public SimpleLink(PointF ptStart, PointF ptEnd)
            : base(ptStart, ptEnd)
        {

        }


		public SimpleLink(PointF[] pts):base(pts)
		{


		}

        //syncfusion compilation update..

        //public SimpleLink(Link.Shapes shapeType):base(shapeType)
        //{

        //}


        //public SimpleLink(Link.Shapes shapeType, PointF[] pts): base (shapeType,  pts)
        //{

        //}

        //public SimpleLink(IPoints linkPoints):base(linkPoints)
        //{

        //}

		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src">Source object to copy from.</param>
		public SimpleLink(SimpleLink src) : base(src)
		{
		}

		/// <summary>
		/// Serialization constructor for symbols.
		/// </summary>
		/// <param name="info">Serialization state information.</param>
		/// <param name="context">Streaming context information.</param>
		protected SimpleLink(SerializationInfo info, StreamingContext context) : base(info, context)
		{
		}

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against.</returns>
		public override object Clone()
		{
			return new SimpleLink(this);
		}

		

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		#endregion

		#region Properties

        //syncfusion compilation change..
        //protected override void OnMoveVertex(VertexEventArgs evtArgs)
        //{
        //    try
        //    {
        //        base.OnMoveVertex (evtArgs);
        //    }
        //    catch
        //    {

        //    }
        //}
        public override void OnVertexChanged(VertexChangeType changeType, int nVertexIdx, PointF ptLocation)
        {
            base.OnVertexChanged(changeType, nVertexIdx, ptLocation);
        }

        //Syncfusion compilation change..

        //[Category("LineCap"),Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public EndPointDecorator EndCap
        //{
        //    get
        //    {
        //        return this.EndPoints.LastEndPointDecorator;
        //    }
        //    set
        //    {
        //        this.EndPoints.LastEndPointDecorator = value;
        //        if(this.EndPoints.LastEndPointDecorator != null)
        //        {
        //            //this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.EndPoints.LastEndPointDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}


        //[Category("LineCap"), Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public EndPointDecorator StartCap
        //{
        //    get
        //    {
        //        return this.EndPoints.FirstEndPointDecorator;
        //    }
        //    set
        //    {
        //        this.EndPoints.FirstEndPointDecorator = value;
        //        if(this.EndPoints.FirstEndPointDecorator != null)
        //        {
        //            //this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.EndPoints.FirstEndPointDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}


		[Category("LineCap"),TypeConverter(typeof(SizeConverter))]
		public Size EndCapSize
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.LastEndPointDecorator != null)
                //    return this.EndPoints.LastEndPointDecorator.Size.ToSize();
                if (this.HeadDecorator != null)
                    return this.HeadDecorator.Size.ToSize();
				else 
					return new Size(0,0);

			}
			set
			{
                //Syncfusion compilation change..
				this.HeadDecorator.Size = value;
			}
		}


		[Category("LineCap"),DefaultValue(typeof(Size),null),TypeConverter(typeof(SizeConverter))]
		public Size StartCapSize
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.FirstEndPointDecorator != null)
                //    return this.EndPoints.FirstEndPointDecorator.Size.ToSize();
                if (this.TailDecorator != null)
                    return this.TailDecorator.Size.ToSize();
				else 
					return new Size(0,0);
			}
			set
			{
                //Syncfusion compilation change..
				this.TailDecorator.Size = value;
			}
		}

		[Category("LineCap")]
		public FillStyle StartCapFillStyle
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.FirstEndPointDecorator != null)
                //    return this.EndPoints.FirstEndPointDecorator.FillStyle;
                if (this.TailDecorator != null)
                    return this.TailDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public FillStyle EndCapFillStyle
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.LastEndPointDecorator != null)
                //    return this.EndPoints.LastEndPointDecorator.FillStyle;
                if (this.HeadDecorator != null)
                    return this.HeadDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public LineStyle EndCapLineStyle
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.LastEndPointDecorator != null)
                //    return this.EndPoints.LastEndPointDecorator.LineStyle;
                if (this.HeadDecorator != null)
                    return this.HeadDecorator.LineStyle;
				else 
					return null;
			}
		}


	
		[Category("LineCap")]
		public LineStyle StartCapLineStyle
		{
			get
			{
                //Syncfusion compilation change..
                //if(this.EndPoints.FirstEndPointDecorator != null)
                //    return this.EndPoints.FirstEndPointDecorator.LineStyle;
                if (this.TailDecorator != null)
                    return this.TailDecorator.LineStyle;
				else 
					return null;
			}
		}

		#endregion

		#region Overrides
        //syncfusion compilation change..

        //protected override void OnPropertyChanged(PropertyEventArgs evtArgs)
        //{
        //    base.OnPropertyChanged (evtArgs);
        //    if(evtArgs.PropertyName == "LineColor")
        //    {
        //        if(this.EndPoints.LastEndPointDecorator != null)
        //        {
        //            this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = (Color)evtArgs.NewValue;
        //            this.EndPoints.LastEndPointDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //        if(this.EndPoints.FirstEndPointDecorator != null)
        //        {
        //            this.EndPoints.FirstEndPointDecorator.LineStyle.LineColor = (Color) evtArgs.NewValue;
        //            this.EndPoints.FirstEndPointDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //    }
			
        //}

        public override void OnPropertyChanged(string strPropertyContainerName, string strPropertyName)
        {
            base.OnPropertyChanged(strPropertyContainerName, strPropertyName);
            if (strPropertyName == "LineColor")
            {
                if (this.HeadDecorator != null)
                {
                    this.HeadDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.HeadDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
                if (this.TailDecorator != null)
                {
                    this.TailDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.TailDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
            }
        }

		#endregion
	}
}
